'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('../button/Button');

var _Button2 = _interopRequireDefault(_Button);

var _buttons = require('../buttons');

var _buttons2 = _interopRequireDefault(_buttons);

var _layout = require('../layout');

var _cover = require('../cover');

var _isString = require('lodash/isString');

var _isString2 = _interopRequireDefault(_isString);

var _modal = require('../modal');

require('../../themes/base/alert.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component;
var AlertMessage = (_temp = _class = function (_Component) {
  _inherits(AlertMessage, _Component);

  function AlertMessage() {
    _classCallCheck(this, AlertMessage);

    return _possibleConstructorReturn(this, (AlertMessage.__proto__ || Object.getPrototypeOf(AlertMessage)).apply(this, arguments));
  }

  _createClass(AlertMessage, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.setDrag();
    }
  }, {
    key: 'getTitle',
    value: function getTitle(type) {
      switch (type) {
        case 'success':
          return '成功';
        case 'info':
          return '提示';
        case 'warning':
          return '警告';
        case 'error':
          return '错误';
        case 'confirm':
          return '提示';
        case 'auth':
          return '权限提醒';
      }
    }
  }, {
    key: 'setDrag',
    value: function setDrag() {
      var _props = this.props,
          isDragged = _props.isDragged,
          show = _props.show;

      if (isDragged) {
        var alert = _reactDom2.default.findDOMNode(this.refs.alert);
        if (show) {
          var header = this.refs.header;
          _modal.MODAL_MOVE.setTarget(alert);
          header.style.cursor = 'move';
          header.onmousedown = _modal.MODAL_MOVE.init;
        } else {
          alert.style.top = null;
          alert.style.left = null;
        }
      }
    }
  }, {
    key: 'getIconClass',
    value: function getIconClass(type) {
      switch (type) {
        case 'success':
          return 'icon-check';
        case 'info':
          return 'icon-info';
        case 'warning':
          return 'icon-warn';
        case 'error':
          return 'icon-error';
        case 'confirm':
          return 'hidden';
        case 'auth':
          return 'hidden';
      }
    }
  }, {
    key: 'handleConfirm',
    value: function handleConfirm(value) {
      var onConfirm = this.props.onConfirm;

      if (typeof onConfirm === 'function') {
        onConfirm(value);
      }
    }
  }, {
    key: 'getButtons',
    value: function getButtons() {
      var type = this.props.type;

      var buttons = [];
      if (type === 'confirm') {
        buttons.push(_jsx(_Button2.default, {
          value: 'cancel',
          onClick: this.handleConfirm.bind(this),
          className: 'btn-grey'
        }, 'cancel', '\u53D6\u6D88'));
      }
      buttons.push(_jsx(_Button2.default, {
        value: 'ok',
        onClick: this.handleConfirm.bind(this)
      }, 'ok', '\u786E\u5B9A'));
      return _jsx(_buttons2.default, {}, void 0, buttons);
    }
  }, {
    key: 'header',
    value: function header() {
      var _props2 = this.props,
          type = _props2.type,
          title = _props2.title;

      var newTitle = title || this.getTitle(type);
      return _react2.default.createElement(
        'div',
        { ref: 'header', className: 'alert-header' },
        _jsx('label', {}, void 0, newTitle)
      );
    }
  }, {
    key: 'content',
    value: function content() {
      var _props3 = this.props,
          type = _props3.type,
          content = _props3.content;

      return _jsx('div', {
        className: 'alert-children'
      }, void 0, type === 'auth' || type === 'confirm' || !(0, _isString2.default)(content) ? content : _jsx('p', {}, void 0, content));
    }
  }, {
    key: 'footer',
    value: function footer() {
      return _jsx('div', {
        className: 'alert-footer'
      }, void 0, this.getButtons.call(this));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props4 = this.props,
          type = _props4.type,
          show = _props4.show,
          size = _props4.size;

      var props = {
        ref: 'alert',
        className: (0, _classnames2.default)(['alert-message', 'alert-' + type, 'alert-' + size]),
        style: { display: show ? 'flex' : 'none' },
        header: this.header.call(this),
        children: this.content.call(this),
        footer: this.footer.call(this)
      };
      return _jsx('div', {}, void 0, _jsx(_cover.Cover, {
        type: 'tip',
        opacity: 0.5,
        show: show
      }), _react2.default.createElement(_layout.LayoutGV, props));
    }
  }]);

  return AlertMessage;
}(Component), _class.defaultProps = {
  type: 'info',
  show: false,
  isDragged: false,
  size: 'md'
}, _temp);
exports.default = AlertMessage;