'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp, _class2, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _button = require('../button');

var _button2 = _interopRequireDefault(_button);

var _utils = require('./utils');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('../../themes/base/avatarcropper.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component;
var AvatarCropper = (_temp = _class = function (_Component) {
  _inherits(AvatarCropper, _Component);

  function AvatarCropper() {
    _classCallCheck(this, AvatarCropper);

    return _possibleConstructorReturn(this, (AvatarCropper.__proto__ || Object.getPrototypeOf(AvatarCropper)).apply(this, arguments));
  }

  _createClass(AvatarCropper, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          cropperOpen = _props.cropperOpen,
          image = _props.image,
          onCrop = _props.onCrop,
          onRequestHide = _props.onRequestHide,
          sizeLimit = _props.sizeLimit;

      var avatarCropperCover = (0, _classnames2.default)(['avatar-cropper-cover', cropperOpen ? '' : 'hidden']);
      var left = (document.body.clientWidth - 450) / 2;
      var props = {
        ref: 'cropper',
        className: (0, _classnames2.default)(['AvatarCropper-base']),
        style: {
          top: '10%',
          bottom: 405,
          left: left,
          display: 'flex'
        }
      };
      return _jsx('div', {
        className: avatarCropperCover
      }, void 0, _react2.default.createElement(
        'div',
        props,
        _jsx(Cropper, {
          image: image,
          onCrop: onCrop,
          onRequestHide: onRequestHide,
          sizeLimit: sizeLimit
        })
      ));
    }
  }]);

  return AvatarCropper;
}(Component), _class.defaultProps = {
  sizeLimit: 1024 * 10
}, _temp);
exports.default = AvatarCropper;
var Cropper = (_temp2 = _class2 = function (_Component2) {
  _inherits(Cropper, _Component2);

  function Cropper(props) {
    _classCallCheck(this, Cropper);

    var _this2 = _possibleConstructorReturn(this, (Cropper.__proto__ || Object.getPrototypeOf(Cropper)).call(this, props));

    _this2.getBlobSizeFromCanvas = function (canvas) {
      var dataURL = canvas.toDataURL('image/jpeg');
      var bstr = atob(dataURL.split(',')[1]);
      var n = bstr.length;
      var u8arr = new Uint8Array(n);
      while (n--) {
        u8arr[n] = bstr.charCodeAt(n);
      }
      var blob = new Blob([u8arr], { type: 'image/jpeg' });
      return blob.size / 1024;
    };

    _this2.state = {
      dragging: false,
      image: {},
      mouse: {
        x: null,
        y: null
      },
      preview: null,
      zoom: 1
    };
    _this2.listeners = [];
    return _this2;
  }

  _createClass(Cropper, [{
    key: 'fitImageToCanvas',
    value: function fitImageToCanvas(width, height) {
      var scaledHeight, scaledWidth;

      var canvasAspectRatio = this.props.height / this.props.width;
      var imageAspectRatio = height / width;

      if (canvasAspectRatio > imageAspectRatio) {
        scaledHeight = this.props.height;
        var scaleRatio = scaledHeight / height;
        scaledWidth = width * scaleRatio;
      } else {
        scaledWidth = this.props.width;
        var _scaleRatio = scaledWidth / width;
        scaledHeight = height * _scaleRatio;
      }

      return { width: scaledWidth, height: scaledHeight };
    }
  }, {
    key: 'prepareImage',
    value: function prepareImage(imageUri) {
      var _this3 = this;

      var img = new Image();
      if (!(0, _utils.isDataURL)(imageUri)) img.crossOrigin = 'anonymous';
      img.onload = function () {
        var scaledImage = _this3.fitImageToCanvas(img.width, img.height);
        scaledImage.resource = img;
        scaledImage.x = 0;
        scaledImage.y = 0;
        _this3.setState({ dragging: false, image: scaledImage, preview: _this3.toDataURL() });
      };
      img.src = imageUri;
    }
  }, {
    key: 'mouseDownListener',
    value: function mouseDownListener(e) {
      this.setState({
        image: this.state.image,
        dragging: true,
        mouse: {
          x: null,
          y: null
        }
      });
    }
  }, {
    key: 'preventSelection',
    value: function preventSelection(e) {
      if (this.state.dragging) {
        e.preventDefault();
        return false;
      }
    }
  }, {
    key: 'mouseUpListener',
    value: function mouseUpListener(e) {
      this.setState({ dragging: false, preview: this.toDataURL() });
    }
  }, {
    key: 'mouseMoveListener',
    value: function mouseMoveListener(e) {
      if (!this.state.dragging) return;

      var mouseX = e.clientX;
      var mouseY = e.clientY;
      var imageX = this.state.image.x;
      var imageY = this.state.image.y;

      var newImage = this.state.image;

      if (this.state.mouse.x && this.state.mouse.y) {
        var dx = this.state.mouse.x - mouseX;
        var dy = this.state.mouse.y - mouseY;

        var bounded = this.boundedCoords(imageX, imageY, dx, dy);

        newImage.x = bounded.x;
        newImage.y = bounded.y;
      }

      this.setState({
        image: this.state.image,
        mouse: {
          x: mouseX,
          y: mouseY
        }
      });
    }
  }, {
    key: 'boundedCoords',
    value: function boundedCoords(x, y, dx, dy) {
      var newX = x - dx;
      var newY = y - dy;

      var scaledWidth = this.state.image.width * this.state.zoom;
      var dw = (scaledWidth - this.state.image.width) / 2;

      var rightEdge = this.props.width;

      if (newX - dw > 0) {
        x = dw;
      } else if (newX < -scaledWidth + rightEdge) {
        x = rightEdge - scaledWidth;
      } else {
        x = newX;
      }

      var scaledHeight = this.state.image.height * this.state.zoom;
      var dh = (scaledHeight - this.state.image.height) / 2;

      var bottomEdge = this.props.height;
      if (newY - dh > 0) {
        y = dh;
      } else if (newY < -scaledHeight + bottomEdge) {
        y = bottomEdge - scaledHeight;
      } else {
        y = newY;
      }

      return { x: x, y: y };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this4 = this;

      var canvas = _reactDom2.default.findDOMNode(this.refs.canvas);
      this.prepareImage(this.props.image);

      this.listeners = {
        mousemove: function mousemove(e) {
          return _this4.mouseMoveListener(e);
        },
        mouseup: function mouseup(e) {
          return _this4.mouseUpListener(e);
        },
        mousedown: function mousedown(e) {
          return _this4.mouseDownListener(e);
        }
      };

      window.addEventListener('mousemove', this.listeners.mousemove, false);
      window.addEventListener('mouseup', this.listeners.mouseup, false);
      canvas.addEventListener('mousedown', this.listeners.mousedown, false);
      document.onselectstart = function (e) {
        return _this4.preventSelection(e);
      };
    }

    // make sure we clean up listeners when unmounted.

  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var canvas = _reactDom2.default.findDOMNode(this.refs.canvas);
      window.removeEventListener('mousemove', this.listeners.mousemove);
      window.removeEventListener('mouseup', this.listeners.mouseup);
      canvas.removeEventListener('mousedown', this.listeners.mousedown);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      var canvas = _reactDom2.default.findDOMNode(this.refs.canvas);
      var context = canvas.getContext('2d');
      context.clearRect(0, 0, this.props.width, this.props.height);
      this.addImageToCanvas(context, this.state.image);
      // const blobSize = this.getBlobSizeFromCanvas(canvas);
      // this.refs.sizeLimit.updateCurrentSize(blobSize);
    }
  }, {
    key: 'addImageToCanvas',
    value: function addImageToCanvas(context, image) {
      if (!image.resource) return;
      context.save();
      context.globalCompositeOperation = 'destination-over';
      var scaledWidth = this.state.image.width * this.state.zoom;
      var scaledHeight = this.state.image.height * this.state.zoom;

      var x = image.x - (scaledWidth - this.state.image.width) / 2;
      var y = image.y - (scaledHeight - this.state.image.height) / 2;

      // need to make sure we aren't going out of bounds here...
      x = Math.min(x, 0);
      y = Math.min(y, 0);
      y = scaledHeight + y >= this.props.height ? y : y + (this.props.height - (scaledHeight + y));
      x = scaledWidth + x >= this.props.width ? x : x + (this.props.width - (scaledWidth + x));

      context.drawImage(image.resource, x, y, image.width * this.state.zoom, image.height * this.state.zoom);
      context.restore();
    }
  }, {
    key: 'toDataURL',
    value: function toDataURL() {
      var canvas = document.createElement('canvas');
      var context = canvas.getContext('2d');

      canvas.width = this.props.width;
      canvas.height = this.props.height;

      this.addImageToCanvas(context, {
        resource: this.state.image.resource,
        x: this.state.image.x,
        y: this.state.image.y,
        height: this.state.image.height,
        width: this.state.image.width
      });

      return canvas.toDataURL();
    }
  }, {
    key: 'handleCrop',
    value: function handleCrop() {
      // const validResult = this.refs.sizeLimit.validate();
      // if (validResult === false) {
      //   return;
      // }

      var canvas = document.createElement('canvas');
      var context = canvas.getContext('2d');

      canvas.width = this.props.width;
      canvas.height = this.props.height;

      this.addImageToCanvas(context, {
        resource: this.state.image.resource,
        x: this.state.image.x,
        y: this.state.image.y,
        height: this.state.image.height,
        width: this.state.image.width
      });

      this.props.onCrop(canvas.toDataURL(), canvas);
    }
  }, {
    key: 'handleZoomUpdate',
    value: function handleZoomUpdate() {
      var newstate = this.state;
      newstate.zoom = _reactDom2.default.findDOMNode(this.refs.zoom).value;
      this.setState({ newstate: newstate });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          width = _props2.width,
          height = _props2.height,
          onRequestHide = _props2.onRequestHide;

      return _jsx('div', {
        className: 'AvatarCropper-canvas'
      }, void 0, _jsx('div', {}, void 0, _react2.default.createElement('canvas', {
        ref: 'canvas',
        width: width,
        height: height })), _jsx('div', {}, void 0, _react2.default.createElement('input', {
        ref: 'zoom',
        type: 'range',
        name: 'zoom',
        onChange: this.handleZoomUpdate.bind(this),
        style: { width: width },
        min: '1',
        max: '3',
        step: '0.01',
        defaultValue: '1'
      })), _jsx('div', {
        className: 'modal-cropper-footer'
      }, void 0, _jsx(_button2.default, {
        onClick: this.handleCrop.bind(this)
      }, void 0, '保存'), _jsx(_button2.default, {
        onClick: onRequestHide
      }, void 0, '关闭')));
    }
  }]);

  return Cropper;
}(Component), _class2.defaultProps = {
  width: 400,
  height: 400,
  zoom: 1
}, _temp2);