'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _isString = require('lodash/isString');

var _isString2 = _interopRequireDefault(_isString);

var _sscAnalytics = require('ssc-analytics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = (_temp = _class = function (_React$Component) {
  _inherits(Button, _React$Component);

  function Button(props) {
    _classCallCheck(this, Button);

    var _this = _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).call(this, props));

    _this.state = {
      active: props.active
    };
    return _this;
  }

  _createClass(Button, [{
    key: 'getClasses',
    value: function getClasses() {
      var className = this.state.active ? 'btn active' : 'btn';
      className = className + ' btn-' + this.props.type;
      return className;
    }
  }, {
    key: 'handleClick',
    value: function handleClick(e) {
      var active = !this.state.active;
      var _props = this.props,
          value = _props.value,
          disabled = _props.disabled,
          track = _props.track;

      if (disabled) {
        return;
      }
      this.setState({ active: active });
      if (this.props.onClick) {
        this.props.onClick(value, e);
      }

      if (track && (0, _isString2.default)(this.props.children)) {
        (0, _sscAnalytics.tracker)('click', this.context.businessKey + '.' + this.props.children, this.context.componentName);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          children = _props2.children,
          className = _props2.className,
          other = _objectWithoutProperties(_props2, ['children', 'className']);

      var buttonProps = Object.assign({}, other);
      delete buttonProps.active;
      delete buttonProps.track;
      var props = {
        className: (0, _classnames2.default)([this.getClasses(), className]),
        onClick: this.handleClick.bind(this)
      };
      return _react2.default.createElement(
        'span',
        _extends({}, buttonProps, props),
        children
      );
    }
  }]);

  return Button;
}(_react2.default.Component), _class.defaultProps = {
  disabled: false,
  active: false,
  value: '',
  type: 'primary',
  track: true
}, _class.contextTypes = {
  businessKey: _propTypes2.default.string,
  componentName: _propTypes2.default.string
}, _temp);
exports.default = Button;