'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _echarts = require('echarts');

var _echarts2 = _interopRequireDefault(_echarts);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _elementResizeEvent = require('element-resize-event');

var _elementResizeEvent2 = _interopRequireDefault(_elementResizeEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component;

var Chart = function (_Component) {
  _inherits(Chart, _Component);

  function Chart(props) {
    _classCallCheck(this, Chart);

    var _this = _possibleConstructorReturn(this, (Chart.__proto__ || Object.getPrototypeOf(Chart)).call(this, props));

    _this.handleDbClick = function () {
      var onDoubleClick = _this.props.onDoubleClick;

      if ((0, _isFunction2.default)(onDoubleClick)) {
        onDoubleClick();
      }
    };

    _this.chart = null;
    return _this;
  }

  _createClass(Chart, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          onReady = _props.onReady,
          onResize = _props.onResize;

      var chart = _echarts2.default.getInstanceByDom(this.refs.chart);
      if (!chart) {
        chart = _echarts2.default.init(this.refs.chart);
      }
      if (this.props.option) {
        chart.setOption(this.props.option, this.props.theme);
      }
      if (onReady) {
        onReady(chart);
      }
      (0, _elementResizeEvent2.default)(this.refs.chart, function (e) {
        chart.resize();
        if ((0, _isFunction2.default)(onResize)) {
          onResize();
        }
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      _echarts2.default.dispose(this.refs.chart);
    }
  }, {
    key: 'render',
    value: function render() {
      var props = {
        ref: 'chart',
        className: (0, _classnames2.default)([this.props.className, 'ss-charts']),
        style: this.props.style,
        onDoubleClick: this.handleDbClick
      };
      return _react2.default.createElement('div', props);
    }
  }]);

  return Chart;
}(Component);

exports.default = Chart;