'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _echarts = require('echarts');

var _echarts2 = _interopRequireDefault(_echarts);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _elementResizeEvent = require('element-resize-event');

var _elementResizeEvent2 = _interopRequireDefault(_elementResizeEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Charts = function (_React$Component) {
  _inherits(Charts, _React$Component);

  function Charts() {
    _classCallCheck(this, Charts);

    return _possibleConstructorReturn(this, (Charts.__proto__ || Object.getPrototypeOf(Charts)).apply(this, arguments));
  }

  _createClass(Charts, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          onResize = _props.onResize,
          onReady = _props.onReady;

      var chart = this.renderEchartDom();
      var onEvents = this.props.onEvents || [];

      var _loop = function _loop(eventName) {
        if (typeof eventName === 'string' && typeof onEvents[eventName] === 'function') {
          chart.on(eventName, function (param) {
            onEvents[eventName](param, chart);
          });
        }
      };

      for (var eventName in onEvents) {
        _loop(eventName);
      }
      if (typeof onReady === 'function') onReady(chart);

      (0, _elementResizeEvent2.default)(this.refs.charts, function () {
        chart.resize();
        if (typeof onResize === 'function') onResize();
      });
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.renderEchartDom();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      _echarts2.default.dispose(this.refs.charts);
    }
  }, {
    key: 'renderEchartDom',
    value: function renderEchartDom() {
      var chart = this.getEchartsInstance();
      chart.setOption(this.props.option, this.props.notMerge || false, this.props.lazyUpdate || false);
      if (this.props.showLoading) chart.showLoading();else chart.hideLoading();

      return chart;
    }
  }, {
    key: 'getEchartsInstance',
    value: function getEchartsInstance() {
      return _echarts2.default.getInstanceByDom(this.refs.charts) || _echarts2.default.init(this.refs.charts, this.props.theme);
    }
  }, {
    key: 'handleDbClick',
    value: function handleDbClick() {
      var onDbClick = this.props.onDbClick;

      if ((0, _isFunction2.default)(onDbClick)) {
        onDbClick();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var props = {
        ref: 'charts',
        className: (0, _classnames2.default)([this.props.className, 'ss-charts']),
        style: this.props.style,
        onDoubleClick: this.handleDbClick.bind(this)
      };
      return _react2.default.createElement('div', props);
    }
  }]);

  return Charts;
}(_react2.default.Component);

exports.default = Charts;