'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Collapse = (_temp = _class = function (_React$Component) {
  _inherits(Collapse, _React$Component);

  function Collapse(props) {
    _classCallCheck(this, Collapse);

    var _this = _possibleConstructorReturn(this, (Collapse.__proto__ || Object.getPrototypeOf(Collapse)).call(this, props));

    _this.EVT_EMITTER = null;
    return _this;
  }

  _createClass(Collapse, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      var isRender = false;
      var _props = this.props,
          isShow = _props.isShow,
          duration = _props.duration,
          content = _props.content;


      if (nextProps.isShow !== isShow) {
        if (isShow) {
          this.onHide();
          return setTimeout(function () {}, duration);
        } else {
          isRender = true;
        }
      }

      if (!(0, _isEqual2.default)(nextProps.content, content)) {
        isRender = true;
      }

      return isRender;
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.calcContentHeight();
      this.EVT_EMITTER = this.calcContentHeight.bind(this);
      window.addEventListener('resize', this.EVT_EMITTER);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.EVT_EMITTER);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.calcContentHeight();
    }
  }, {
    key: 'calcContentHeight',
    value: function calcContentHeight() {
      var isShow = this.props.isShow;

      if (isShow) {
        this.onShow();
      }
    }
  }, {
    key: 'onShow',
    value: function onShow() {
      var content = this.refs.content;
      var container = this.refs.container;
      container.style.paddingBottom = '';
      var paddingBottom = window.getComputedStyle(container, null).paddingBottom;
      container.style.height = content.offsetHeight + parseInt(paddingBottom, 10) + 'px';
    }
  }, {
    key: 'onHide',
    value: function onHide() {
      var container = this.refs.container;
      container.style.paddingBottom = '0px';
      container.style.height = '0px';
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          className = _props2.className,
          content = _props2.content,
          isShow = _props2.isShow,
          duration = _props2.duration;

      var style = {
        transitionDuration: duration + 'ms'
      };
      return _react2.default.createElement(
        'div',
        { ref: 'container', className: (0, _classnames2.default)('collapsing', className), style: style },
        isShow ? _react2.default.createElement(
          'div',
          { ref: 'content' },
          content
        ) : ''
      );
    }
  }]);

  return Collapse;
}(_react2.default.Component), _class.defaultProps = {
  duration: 350
}, _temp);
exports.default = Collapse;