'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getAngle(r, angle, x0, y0) {
  var x1 = x0 + r * Math.cos(angle * Math.PI / 180);
  var y1 = y0 + r * Math.sin(angle * Math.PI / 180);
  return [x1.toFixed(2), y1.toFixed(2)];
}

/**
 * @param {count} point's count
 * @param {r} radius
 * @param {angle} init angle
 * @param {x0} center point x
 * @param {y0} center point y
 */
function getPositions(count) {
  var r = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 50;
  var angle = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
  var x0 = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : r;
  var y0 = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : r;

  var pos = [];
  var step = 360 / count;
  for (var i = 0; i < count; i++) {
    pos.push(getAngle(r, step * i + angle, x0, y0));
  }
  return pos;
}

var poslist = getPositions(12, 50, -90);

var _ref = _jsx('i', {
  className: 'icon close'
});

var Clock = function (_Component) {
  _inherits(Clock, _Component);

  function Clock(props) {
    _classCallCheck(this, Clock);

    var _this = _possibleConstructorReturn(this, (Clock.__proto__ || Object.getPrototypeOf(Clock)).call(this, props));

    _this.state = {
      current: props.current,
      stage: props.stage || 'clock',
      active: props.active,
      am: props.current.hour() < 12
    };
    return _this;
  }

  _createClass(Clock, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.current !== this.props.current) {
        this.setState({ current: nextProps.current, am: nextProps.current.hour() < 12 });
      }
    }
  }, {
    key: 'changeTimeStage',
    value: function changeTimeStage(stage) {
      this.setState({ stage: stage, active: true });
    }
  }, {
    key: 'setValue',
    value: function setValue(value) {
      var d = {};
      d[this.state.stage] = value;
      this.props.onTimeChange(d);
    }
  }, {
    key: 'close',
    value: function close() {
      if (!this.props.timeOnly) {
        this.setState({ active: false });
      }
    }
  }, {
    key: 'getRotate',
    value: function getRotate(type) {
      var current = this.state.current;
      var value = void 0;
      var max = type === 'hour' ? 12 : 60;

      switch (type) {
        case 'hour':
          value = current.hour() + current.minute() / 60;
          break;
        case 'minute':
          value = current.minute() + current.second() / 60;
          break;
        case 'second':
          value = current.second();
          break;
      }

      value = value * 360 / max - 90;
      return 'rotate(' + value + 'deg)';
    }
  }, {
    key: 'renderPointer',
    value: function renderPointer() {
      var stage = this.state.stage;

      var pointer = function pointer(type, context) {
        var rotate = context.getRotate(type);
        return _jsx('div', {
          style: { transform: rotate, WebkitTransform: rotate },
          className: (0, _classnames2.default)(type, { active: stage === type })
        });
      };

      return _jsx('div', {
        className: 'pointer'
      }, void 0, pointer('hour', this), pointer('minute', this), pointer('second', this));
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var steps = [];
      var stage = this.state.stage;
      var step = stage === 'hour' || stage === 'clock' ? 1 : 5;

      for (var i = 0, s; i < 12; i++) {
        s = i * step;
        if (!this.state.am && stage === 'hour') {
          s += 12;
        }
        steps.push(s);
      }

      var sets = steps.map(function (s, i) {
        var _this2 = this;

        var pos = poslist[i];
        var left = pos[0] + '%';
        var top = pos[1] + '%';
        return _jsx('div', {
          onClick: function onClick() {
            _this2.setValue(s);
          },
          className: (0, _classnames2.default)('clock-set'),
          style: { left: left, top: top }
        }, i, s);
      }, this);

      var className = (0, _classnames2.default)('clock-wrapper', { active: this.state.active });

      return _jsx('div', {
        className: className
      }, void 0, _jsx('div', {
        onClick: this.close.bind(this),
        className: 'clock-overlay'
      }), !this.props.timeOnly && _jsx('div', {
        onClick: this.close.bind(this),
        className: 'clock-close'
      }, void 0, _ref), _jsx('div', {
        className: 'clock'
      }, void 0, _jsx('div', {
        className: 'clock-inner'
      }, void 0, sets), this.renderPointer(), stage === 'hour' && _jsx('div', {}, void 0, _jsx('div', {
        onClick: function onClick() {
          _this3.setState({ am: true });
        },
        className: (0, _classnames2.default)('time-am', { active: this.state.am })
      }, void 0, 'AM'), _jsx('div', {
        onClick: function onClick() {
          _this3.setState({ am: false });
        },
        className: (0, _classnames2.default)('time-pm', { active: !this.state.am })
      }, void 0, 'PM'))));
    }
  }]);

  return Clock;
}(_react.Component);

exports.default = Clock;