'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _index = require('./index');

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Pair = (_temp = _class = function (_React$Component) {
  _inherits(Pair, _React$Component);

  function Pair(props) {
    _classCallCheck(this, Pair);

    var _this = _possibleConstructorReturn(this, (Pair.__proto__ || Object.getPrototypeOf(Pair)).call(this, props));

    _this.state = {
      startDate: _this.props.startDate,
      endDate: _this.props.endDate
    };
    return _this;
  }

  _createClass(Pair, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var startDate = nextProps.startDate,
          endDate = nextProps.endDate;

      if (!(0, _isEqual2.default)(startDate, this.props.startDate) || !(0, _isEqual2.default)(endDate, this.props.endDate)) {
        if (!(0, _isEmpty2.default)(startDate) && !(0, _isEmpty2.default)(endDate)) {
          this.setState({ startDate: startDate, endDate: endDate });
        }
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !(0, _isEqual2.default)(nextProps, this.props) || !(0, _isEqual2.default)(this.state, nextState);
    }
  }, {
    key: 'getValue',
    value: function getValue() {
      var startDate = this.refs.startDate.getValue();
      var endDate = this.refs.endDate.getValue();
      this.setState({ startDate: startDate, endDate: endDate });
      return { startDate: startDate, endDate: endDate };
    }
  }, {
    key: 'setValue',
    value: function setValue(startDate, endDate) {
      this.setState({ startDate: startDate, endDate: endDate }, this.onChange.bind(this));
    }
  }, {
    key: 'onChange',
    value: function onChange() {
      if ((0, _isFunction2.default)(this.props.onChange)) {
        this.props.onChange(this.getValue());
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          names = _props.names,
          min = _props.min,
          max = _props.max,
          con = _props.con,
          other = _objectWithoutProperties(_props, ['names', 'min', 'max', 'con']);

      var _state = this.state,
          startDate = _state.startDate,
          endDate = _state.endDate;

      return _jsx('div', {}, void 0, _react2.default.createElement(_index.Datepicker, _extends({ ref: 'startDate', value: startDate, name: names[0], min: min, max: endDate }, other, { onChange: this.onChange.bind(this) })), con, _react2.default.createElement(_index.Datepicker, _extends({ ref: 'endDate', value: endDate, name: names[1], min: startDate, max: max }, other, { onChange: this.onChange.bind(this) })));
    }
  }]);

  return Pair;
}(_react2.default.Component), _class.defaultProps = {
  con: _jsx('label', {
    className: 'cm-datetime-symbol'
  }, void 0, '-'),
  names: []
}, _temp);
exports.default = Pair;