'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _ref = _jsx('i', {
  className: 'icon angle-up'
});

var _ref2 = _jsx('i', {
  className: 'icon angle-down'
});

var TimeSet = function (_Component) {
  _inherits(TimeSet, _Component);

  function TimeSet(props) {
    _classCallCheck(this, TimeSet);

    var _this = _possibleConstructorReturn(this, (TimeSet.__proto__ || Object.getPrototypeOf(TimeSet)).call(this, props));

    _this.state = {
      value: props.value || 0,
      type: props.type
    };
    return _this;
  }

  _createClass(TimeSet, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.props.value) {
        this.setState({ value: nextProps.value });
      }
    }
  }, {
    key: 'add',
    value: function add() {
      var value = this.state.value;
      var max = this.props.type === 'hour' ? 24 : 60;
      value += 1;
      if (value >= max) {
        value = 0;
      }
      this.changeTime(value);
    }
  }, {
    key: 'sub',
    value: function sub() {
      var value = this.state.value;
      var max = this.props.type === 'hour' ? 23 : 59;
      value -= 1;
      if (value < 0) {
        value = max;
      }
      this.changeTime(value);
    }
  }, {
    key: 'changeTime',
    value: function changeTime(value) {
      var d = {};
      d[this.props.type] = value;
      var success = this.props.onTimeChange(d);
      if (!success) {
        return;
      }
      this.setState({ value: value });
    }
  }, {
    key: 'setValue',
    value: function setValue(value) {
      this.setState({ value: value });
    }
  }, {
    key: 'changeStage',
    value: function changeStage() {
      this.props.onStageChange(this.props.type);
    }
  }, {
    key: 'render',
    value: function render() {
      return _jsx('div', {
        onClick: this.changeStage.bind(this),
        className: 'time-set'
      }, void 0, _jsx('div', {
        className: 'text'
      }, void 0, _jsx('span', {}, void 0, this.state.value), _jsx('a', {
        onClick: this.add.bind(this),
        className: 'add'
      }, void 0, _ref), _jsx('a', {
        onClick: this.sub.bind(this),
        className: 'sub'
      }, void 0, _ref2)));
    }
  }]);

  return TimeSet;
}(_react.Component);

exports.default = TimeSet;