'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _cover = require('../cover');

var _tabwidget = require('../tabwidget');

var _tabwidget2 = _interopRequireDefault(_tabwidget);

var _CustomEmo = require('./CustomEmo');

var _CustomEmo2 = _interopRequireDefault(_CustomEmo);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component;

var _ref = _jsx('i', {
  className: 'icon-font icon-smile'
});

var _ref2 = _jsx('i', {
  className: 'icon-font icon-star'
});

var Emoji = (_temp = _class = function (_Component) {
  _inherits(Emoji, _Component);

  function Emoji(props) {
    _classCallCheck(this, Emoji);

    var _this = _possibleConstructorReturn(this, (Emoji.__proto__ || Object.getPrototypeOf(Emoji)).call(this, props));

    _this.handleClick = function (emo) {
      var onChange = _this.props.onChange;

      if ((0, _isFunction2.default)(onChange)) {
        onChange(emo);
      }
      _this.setState({ show: false });
    };

    _this.handleUpdate = function (files) {
      var collectEmo = _this.props.collectEmo;

      if ((0, _isFunction2.default)(collectEmo)) {
        collectEmo({
          key: _this.props.messageKey,
          files: files
        });
      }
    };

    _this.handleTabWidgetChange = function (index) {
      _this.index = index;
    };

    _this.index = 0;
    return _this;
  }

  _createClass(Emoji, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var show = nextProps.show;

      if (!(0, _isEqual2.default)(show, this.props.show) && !show) {
        this.index = 0;
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var should = false;
      if (!(0, _isEqual2.default)(this.props.customEmo, nextProps.customEmo)) {
        should = true;
      }
      if (!(0, _isEqual2.default)(this.props.x, nextProps.x)) {
        should = true;
      }
      if (!(0, _isEqual2.default)(this.props.y, nextProps.y)) {
        should = true;
      }
      if (!(0, _isEqual2.default)(this.props.show, nextProps.show)) {
        should = true;
      }
      return should;
    }
  }, {
    key: 'handleHidden',
    value: function handleHidden(e) {
      e.preventDefault();
      var onHide = this.props.onHide;

      if ((0, _isFunction2.default)(onHide)) {
        onHide();
      }
      this.setState({ show: false });
    }
  }, {
    key: 'getEmoji',
    value: function getEmoji() {
      var _this2 = this;

      var props = {
        className: (0, _classnames2.default)(['emoji-page'])
      };
      var emojis = (0, _map2.default)(EmojiNames, function (name) {
        var className = (0, _classnames2.default)(['emojione', name]);
        return _jsx('li', {}, 'emojione-' + name, _jsx('a', {
          onClick: _this2.handleClick.bind(_this2, { emo: name, type: 'emo', isDelete: false })
        }, void 0, _jsx('div', {
          className: className
        })));
      });
      return _react2.default.createElement(
        'div',
        props,
        emojis
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          x = _props.x,
          y = _props.y,
          show = _props.show,
          customEmo = _props.customEmo,
          onMouseOver = _props.onMouseOver,
          onMouseOut = _props.onMouseOut,
          defaultEmo = _props.defaultEmo;

      return _jsx(_cover.SingleCover, {
        show: show,
        onClick: this.handleHidden.bind(this)
      }, void 0, _jsx(_tabwidget2.default, {
        className: 'emoji-widget',
        style: { top: y - 308 + 'px', left: x + 'px' },
        tabs: [_ref, _ref2],
        direction: 'bottom',
        selectedIndex: this.index,
        onChange: this.handleTabWidgetChange
      }, void 0, this.getEmoji.call(this), _jsx(_CustomEmo2.default, {
        emos: customEmo,
        defaultEmo: defaultEmo,
        onMouseOver: onMouseOver,
        onMouseOut: onMouseOut,
        sendFile: this.handleUpdate,
        onChange: function onChange(url, isDelete) {
          return _this3.handleClick({ emo: url, type: 'collectEmo', isDelete: isDelete });
        }
      })));
    }
  }]);

  return Emoji;
}(Component), _class.defaultProps = {
  x: 0,
  y: 0,
  show: false,
  customEmo: [],
  defaultEmo: [],
  messageKey: undefined
}, _temp);

var EmojiNames = ['_1f620', '_1f60a', '_1f60c', '_1f60d', '_1f60e', '_1f60f', '_1f61a', '_1f61b', '_1f61c', '_1f61d', '_1f61e', '_1f61f', '_1f62a', '_1f62b', '_1f62c', '_1f62d', '_1f62e', '_1f62f', '_1f600', '_1f601', '_1f602', '_1f603', '_1f604', '_1f605', '_1f606', '_1f607', '_1f608', '_1f609', '_1f610', '_1f611', '_1f612', '_1f613', '_1f614', '_1f615', '_1f616', '_1f617', '_1f618', '_1f619', '_1f60b', '_1f621', '_1f622', '_1f623', '_1f624', '_1f625', '_1f626', '_1f627', '_1f628', '_1f629', '_1f630', '_1f631', '_1f632', '_1f633', '_1f634', '_1f635', '_1f636', '_1f637', '_1f638', '_1f639', '_1f640', '_1f641', '_1f642', '_1f643', '_1f644', '_1f910', '_1f911', '_1f912', '_1f913', '_1f914', '_1f915', '_1f917', '_1f920', '_1f923', '_1f924', '_1f925', '_263a', '_2639'];

exports.default = Emoji;