'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _select = require('../select');

var _select2 = _interopRequireDefault(_select);

var _span = require('../span');

var _span2 = _interopRequireDefault(_span);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _sscAnalytics = require('ssc-analytics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component;

var _ref = _jsx(_span2.default, {});

var Constellation = (_temp = _class = function (_Component) {
  _inherits(Constellation, _Component);

  function Constellation(props) {
    _classCallCheck(this, Constellation);

    var _this = _possibleConstructorReturn(this, (Constellation.__proto__ || Object.getPrototypeOf(Constellation)).call(this, props));

    _this.getValue = function () {
      return _this.state.value;
    };

    _this.state = {
      value: _this.props.value
    };
    return _this;
  }

  _createClass(Constellation, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (!(0, _isEqual2.default)(nextProps.value, this.props.value)) {
        this.setState({ value: nextProps.value });
      }
    }
  }, {
    key: 'handleChange',
    value: function handleChange(value) {
      this.setState({
        value: value
      });
      (0, _sscAnalytics.tracker)('click', this.context.businessKey + '.update-constellation', this.context.componentName);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          readOnly = _props.readOnly,
          isPublic = _props.isPublic;
      var value = this.state.value;

      if (readOnly === true) {
        if (isPublic === false) {
          return _ref;
        } else {
          var text = '';
          (0, _map2.default)(allConstellation, function (constellation) {
            if ((0, _isEqual2.default)(value, constellation.id)) {
              text = constellation.text;
            }
          });
          var name = (0, _classnames2.default)([className, 'form-control-readonly-text', 'reg-input']);
          return _jsx(_span2.default, {
            className: name
          }, void 0, text);
        }
      }
      var props = {
        ref: 'select',
        className: (0, _classnames2.default)([className, 'reg-input']),
        value: value,
        data: allConstellation,
        onChange: this.handleChange.bind(this)
      };
      return _react2.default.createElement(_select2.default, props);
    }
  }]);

  return Constellation;
}(Component), _class.defaultProps = {
  readOnly: true,
  isPublic: true
}, _class.contextTypes = {
  businessKey: _propTypes2.default.string,
  componentName: _propTypes2.default.string
}, _temp);


var allConstellation = [{ id: '1', text: '水瓶座' }, { id: '2', text: '双鱼座' }, { id: '3', text: '白羊座' }, { id: '4', text: '金牛座' }, { id: '5', text: '双子座' }, { id: '6', text: '巨蟹座' }, { id: '7', text: '狮子座' }, { id: '8', text: '处女座' }, { id: '9', text: '天秤座' }, { id: '10', text: '天蝎座' }, { id: '11', text: '射手座' }, { id: '12', text: '摩羯座' }];

exports.default = Constellation;