'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _isNull = require('lodash/isNull');

var _isNull2 = _interopRequireDefault(_isNull);

var _isObject = require('lodash/isObject');

var _isObject2 = _interopRequireDefault(_isObject);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component,
    cloneElement = _react2.default.cloneElement;

var Form = function (_Component) {
  _inherits(Form, _Component);

  function Form(props) {
    _classCallCheck(this, Form);

    var _this = _possibleConstructorReturn(this, (Form.__proto__ || Object.getPrototypeOf(Form)).call(this, props));

    _this.isVerified = function () {
      var verified = true;
      (0, _map2.default)(_this.items, function (c) {
        if (!_this.refs[c].getWrappedInstance().isVerified()) {
          verified = false;
        }
      });
      return verified;
    };

    _this.getValue = function () {
      var verified = _this.isVerified();
      if (!verified) {
        return false;
      }
      var data = {};
      (0, _map2.default)(_this.items, function (c) {
        data = assign(data, _this.refs[c].getWrappedInstance().getValue());
      });
      return data;
    };

    _this.getInstanceByKey = function (key) {
      return _this.refs[key].getWrappedInstance().getInstance();
    };

    _this.items = [];
    return _this;
  }

  _createClass(Form, [{
    key: 'handleSubmit',
    value: function handleSubmit() {
      var verified = this.isVerified();
      if (!verified) {
        return false;
      }
      var onSubmit = this.props.onSubmit;

      if ((0, _isFunction2.default)(onSubmit)) {
        onSubmit(this.getValue());
      }
    }
  }, {
    key: 'renderChildren',
    value: function renderChildren(children) {
      var _this2 = this;

      this.items = [];
      var child = [];
      (0, _map2.default)((0, _isArray2.default)(children) ? children : [children], function (c, index) {
        if ((0, _isNil2.default)(c) || (0, _isEmpty2.default)(c) || (0, _isNull2.default)(c)) {
          return false;
        }
        if ((0, _isObject2.default)(c)) {
          var key = 'formControl' + index;
          _this2.items.push(key);
          child.push(cloneElement(c, { key: key, ref: key }));
        } else if ((0, _isArray2.default)(c)) {
          var array = _this2.renderChildren.call(_this2, c);
          if (array.length > 0) {
            (0, _map2.default)(array, function (ob) {
              return child.push(ob);
            });
          }
        }
      });
      return child;
    }
  }, {
    key: 'render',
    value: function render() {
      var className = this.props.className;

      var props = {
        onSubmit: this.handleSubmit.bind(this),
        className: (0, _classnames2.default)(['ss-form', className])
      };
      return _react2.default.createElement(
        'form',
        props,
        this.renderChildren.call(this, this.props.children)
      );
    }
  }]);

  return Form;
}(Component);

exports.default = Form;