'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _isObject = require('lodash/isObject');

var _isObject2 = _interopRequireDefault(_isObject);

var _assign = require('lodash/assign');

var _assign2 = _interopRequireDefault(_assign);

var _isNull = require('lodash/isNull');

var _isNull2 = _interopRequireDefault(_isNull);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component,
    cloneElement = _react2.default.cloneElement;
var FormControlGroup = (_temp = _class = function (_Component) {
  _inherits(FormControlGroup, _Component);

  function FormControlGroup(props) {
    _classCallCheck(this, FormControlGroup);

    var _this = _possibleConstructorReturn(this, (FormControlGroup.__proto__ || Object.getPrototypeOf(FormControlGroup)).call(this, props));

    _this.isVerified = function () {
      var verified = true;
      (0, _map2.default)(_this.items, function (c) {
        if (!_this.refs[c].getWrappedInstance().isVerified()) {
          verified = false;
        }
      });
      return verified;
    };

    _this.getValue = function () {
      var verified = _this.isVerified();
      if (!verified) {
        return false;
      }
      var data = {};
      (0, _map2.default)(_this.items, function (c) {
        data = (0, _assign2.default)(data, _this.refs[c].getWrappedInstance().getValue());
      });
      return data;
    };

    _this.getInstance = function () {
      return _this;
    };

    _this.items = [];
    return _this;
  }

  _createClass(FormControlGroup, [{
    key: 'renderChildren',
    value: function renderChildren(children) {
      var _this2 = this;

      this.items = [];
      var childArray = [];
      if ((0, _isArray2.default)(children)) {
        (0, _map2.default)(children, function (child, index) {
          _this2.renderChild(child, index, _this2.items, childArray);
        });
      } else if ((0, _isObject2.default)(children)) {
        this.renderChild(children, 0, this.items, childArray);
      }
      return childArray;
    }
  }, {
    key: 'renderChild',
    value: function renderChild(child, index, items, elements) {
      if ((0, _isNil2.default)(child) || (0, _isEmpty2.default)(child) || (0, _isNull2.default)(child)) {
        return;
      }
      var key = 'formControlGroup' + index;
      items.push(key);
      elements.push(cloneElement(child, { key: key, ref: key }));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          grid = _props.grid,
          children = _props.children;

      var props = {
        className: (0, _classnames2.default)(['ss-form-control-group', className]),
        style: { flex: '0 0 ' + grid * 100 + '%' }
      };
      return _react2.default.createElement(
        'div',
        props,
        this.renderChildren.call(this, children)
      );
    }
  }]);

  return FormControlGroup;
}(Component), _class.defaultProps = {
  grid: 1
}, _temp);
exports.default = FormControlGroup;