'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _radio = require('../radio');

var _span = require('../span');

var _span2 = _interopRequireDefault(_span);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _sscAnalytics = require('ssc-analytics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component;
var Gender = (_temp = _class = function (_Component) {
  _inherits(Gender, _Component);

  function Gender(props) {
    _classCallCheck(this, Gender);

    var _this = _possibleConstructorReturn(this, (Gender.__proto__ || Object.getPrototypeOf(Gender)).call(this, props));

    _this.getValue = function () {
      return _this.state.selected;
    };

    _this.state = {
      selected: _this.initGenderValue(_this.props.selected)
    };
    return _this;
  }

  _createClass(Gender, [{
    key: 'initGenderValue',
    value: function initGenderValue(value) {
      if ((0, _isNil2.default)(value) || !(0, _isEqual2.default)(value, '1') && !(0, _isEqual2.default)(value, '2')) {
        return '1';
      }
      return value;
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (!(0, _isEqual2.default)(nextProps.selected, this.props.selected)) {
        this.setState({ selected: nextProps.selected });
      }
    }
  }, {
    key: 'handleChange',
    value: function handleChange(value) {
      this.setState({
        selected: value
      });
      (0, _sscAnalytics.tracker)('click', this.context.businessKey + '.update-gender', this.context.componentName);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          name = _props.name,
          readOnly = _props.readOnly;
      var selected = this.state.selected;

      if (readOnly === true) {
        var text = '';
        (0, _map2.default)(allGenders, function (gender) {
          if ((0, _isEqual2.default)(selected, gender.value)) {
            text = gender.text;
          }
        });
        var _name = (0, _classnames2.default)([className, 'form-control-readonly-text']);
        return _jsx(_span2.default, {
          className: _name
        }, void 0, text);
      }
      var props = {
        ref: 'radioGroup',
        name: name,
        selected: selected,
        radios: allGenders,
        onChange: this.handleChange.bind(this)
      };
      return _react2.default.createElement(_radio.RadioGroup, props);
    }
  }]);

  return Gender;
}(Component), _class.defaultProps = {
  name: '',
  selected: '1',
  readOnly: true
}, _class.contextTypes = {
  businessKey: _propTypes2.default.string,
  componentName: _propTypes2.default.string
}, _temp);


var allGenders = [{ text: '男', value: '1' }, { text: '女', value: '2' }];

exports.default = Gender;