'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _modal = require('../modal');

var _modal2 = _interopRequireDefault(_modal);

var _button = require('../button');

var _button2 = _interopRequireDefault(_button);

var _AvatarCropper = require('../avatacropper/AvatarCropper');

var _AvatarCropper2 = _interopRequireDefault(_AvatarCropper);

var _sscAnalytics = require('ssc-analytics');

require('../../themes/base/headImage.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component;
var HeadImage = (_temp = _class = function (_Component) {
  _inherits(HeadImage, _Component);

  function HeadImage(props) {
    _classCallCheck(this, HeadImage);

    var _this = _possibleConstructorReturn(this, (HeadImage.__proto__ || Object.getPrototypeOf(HeadImage)).call(this, props));

    _this.handleFileChange = function (file, dataURI) {
      _this.setState({
        file: file,
        img: dataURI,
        cropperOpen: true
      });
    };

    _this.handleCrop = function (dataURI, canvas) {
      var uploadFile = _this.props.uploadFile;

      if (uploadFile) {
        var ratio = _this.validateImgSize(canvas);
        var dataURL = canvas.toDataURL('image/jpeg', ratio);
        var blob = _this.dataURLtoBlob(dataURL);
        var formData = new FormData();
        formData.append('file', blob, 'fileName');
        uploadFile(formData);
      }
      _this.setState({
        cropperOpen: false,
        img: null
      });
    };

    _this.dataURLtoBlob = function (dataURL) {
      var bstr = atob(dataURL.split(',')[1]);
      var n = bstr.length;
      var u8arr = new Uint8Array(n);
      while (n--) {
        u8arr[n] = bstr.charCodeAt(n);
      }
      return new Blob([u8arr], { type: 'image/jpeg' });
    };

    _this.handleRequestHide = function () {
      _this.setState({
        cropperOpen: false
      });
    };

    _this.state = {
      src: _this.props.src,
      cropperOpen: false,
      img: null,
      imgSelected: -1
    };
    return _this;
  }

  _createClass(HeadImage, [{
    key: 'updateUrl',
    value: function updateUrl(newUrl) {
      this.setState({
        src: newUrl
      });
    }
  }, {
    key: 'handleClick',
    value: function handleClick(name) {
      if (!(0, _isNil2.default)(name) && !(0, _isEqual2.default)(name, '')) {
        this.setState({
          src: '/images/photo/' + name.substring(1) + '.png',
          imgSelected: name
        });
        (0, _sscAnalytics.tracker)('click', this.context.businessKey + '.update-systemImage', this.context.componentName);
      }
    }
  }, {
    key: 'handleFileUpload',
    value: function handleFileUpload() {
      var input = document.getElementById('input');
      input.click();
      (0, _sscAnalytics.tracker)('click', this.context.businessKey + '.update-customImage', this.context.componentName);
    }
  }, {
    key: 'handleHidden',
    value: function handleHidden() {
      var _props = this.props,
          onHide = _props.onHide,
          src = _props.src;

      if ((0, _isFunction2.default)(onHide)) {
        this.state.imgSelected = -1;
        this.state.src = src;
        onHide();
      }
    }
  }, {
    key: 'handleConfirm',
    value: function handleConfirm() {
      var _props2 = this.props,
          onChange = _props2.onChange,
          onHide = _props2.onHide;

      if ((0, _isFunction2.default)(onChange)) {
        var src = this.state.src;

        onChange(src);
        if ((0, _isFunction2.default)(onHide)) {
          this.state.imgSelected = -1;
          onHide();
        }
      }
    }
  }, {
    key: 'calculateImgSize',
    value: function calculateImgSize(canvas, ratio) {
      var dataURL = canvas.toDataURL('image/jpeg', ratio);
      var blob = this.dataURLtoBlob(dataURL);
      return blob.size;
    }
  }, {
    key: 'validateImgSize',
    value: function validateImgSize(canvas) {
      var ratio = void 0;
      var curSize = void 0;
      var sizeLimit = this.props.sizeLimit;

      var maxSize = sizeLimit * 1024;
      var dataURL = canvas.toDataURL('image/jpeg', 0.92);
      var blob = this.dataURLtoBlob(dataURL);
      if (blob.size > maxSize) {
        for (var i = 0.91; i > 0; i = i - 0.01) {
          curSize = this.calculateImgSize(canvas, i);
          if (curSize <= maxSize) {
            ratio = i;
            break;
          }
        }
      } else {
        ratio = 0.92;
      }
      return ratio;
    }
  }, {
    key: 'getHeadImages',
    value: function getHeadImages() {
      var _this2 = this;

      var imgSelected = this.state.imgSelected;

      var imgContainerClass = 'img-container';
      var imgSelectedClass = void 0;
      return (0, _map2.default)(ImageNames, function (name) {
        imgSelectedClass = (0, _isEqual2.default)(name, imgSelected) ? 'img-selected' : '';
        return _jsx('li', {}, 'headImage-' + name, _jsx('a', {
          onClick: _this2.handleClick.bind(_this2, name)
        }, void 0, _jsx('div', {
          className: (0, _classnames2.default)([imgContainerClass, imgSelectedClass])
        }, void 0, _jsx('div', {
          className: (0, _classnames2.default)(['headImage', name])
        }))));
      });
    }
  }, {
    key: 'getRightPartImg',
    value: function getRightPartImg() {
      var src = this.state.src;

      var imgProps = {
        className: '',
        width: '100px',
        height: '100px',
        style: { borderRadius: 50 + '%' },
        src: src
      };
      return _jsx('div', {
        className: 'right-img'
      }, void 0, _react2.default.createElement('img', imgProps));
    }
  }, {
    key: 'getRightPartBtns',
    value: function getRightPartBtns() {
      var style = { background: '#444444' };
      return _jsx('div', {
        className: 'right-btns'
      }, void 0, _jsx(_button2.default, {
        style: style,
        onClick: this.handleFileUpload.bind(this)
      }, void 0, '\u6D4F\u89C8'), _jsx('div', {}, void 0, _jsx(FileUpload, {
        id: 'fileUpload',
        handleFileChange: this.handleFileChange
      })), _jsx(_button2.default, {
        style: style,
        onClick: this.handleHidden.bind(this)
      }, void 0, '\u53D6\u6D88'), _jsx(_button2.default, {
        onClick: this.handleConfirm.bind(this)
      }, void 0, '\u786E\u5B9A'));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          show = _props3.show,
          sizeLimit = _props3.sizeLimit;
      var _state = this.state,
          cropperOpen = _state.cropperOpen,
          img = _state.img;

      var modalProps = {
        className: 'headImage-modal',
        header: '修改头像',
        buttons: {},
        isDragged: true,
        isShown: show,
        width: 520 + 24,
        height: '100%',
        onClose: this.handleHidden.bind(this)
      };
      return _react2.default.createElement(
        _modal2.default,
        modalProps,
        _jsx('div', {
          style: { display: 'flex' }
        }, void 0, _jsx('div', {
          className: 'head-image-page'
        }, void 0, this.getHeadImages.call(this)), _jsx('div', {
          className: 'head-image-right'
        }, void 0, this.getRightPartImg.call(this), this.getRightPartBtns.call(this))),
        cropperOpen && _jsx(_AvatarCropper2.default, {
          onRequestHide: this.handleRequestHide,
          cropperOpen: cropperOpen,
          onCrop: this.handleCrop,
          image: img,
          sizeLimit: sizeLimit
        })
      );
    }
  }]);

  return HeadImage;
}(Component), _class.defaultProps = {
  show: false,
  src: '',
  sizeLimit: 1024 * 10,
  uploadFile: undefined
}, _class.contextTypes = {
  businessKey: _propTypes2.default.string,
  componentName: _propTypes2.default.string
}, _temp);

var ImageNames = ['_1', '_2', '_3', '_4', '_5', '_6', '_7', '_8', '_9', '_10', '_11', '_12', '_13', '_14', '_15', '_16', '_17', '_18', '_19', '_20', '_21', '_22', '_23', '_24', '_25', '_26', '_27', '_28', '_29', '_30', '_31', '_32', '_33', '_34', '_35', '_0'];

exports.default = HeadImage;

var FileUpload = function (_Component2) {
  _inherits(FileUpload, _Component2);

  function FileUpload() {
    var _ref;

    var _temp2, _this3, _ret;

    _classCallCheck(this, FileUpload);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp2 = (_this3 = _possibleConstructorReturn(this, (_ref = FileUpload.__proto__ || Object.getPrototypeOf(FileUpload)).call.apply(_ref, [this].concat(args))), _this3), _this3.handleFile = function (e) {
      var reader = new FileReader();
      var file = e.target.files[0];

      if (!file) return;

      reader.onload = function (img) {
        _reactDom2.default.findDOMNode(this.refs.in).value = '';
        this.props.handleFileChange(file, img.target.result);
      }.bind(_this3);
      reader.readAsDataURL(file);
    }, _temp2), _possibleConstructorReturn(_this3, _ret);
  }

  _createClass(FileUpload, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement('input', { ref: 'in', id: 'input', type: 'file', accept: 'image/*', style: { display: 'none' }, onChange: this.handleFile });
    }
  }]);

  return FileUpload;
}(Component);