'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _HeadImage = require('./HeadImage');

var _HeadImage2 = _interopRequireDefault(_HeadImage);

var _sscAnalytics = require('ssc-analytics');

require('../../themes/base/ImageEditor.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component;
var ImageEditor = (_temp = _class = function (_Component) {
  _inherits(ImageEditor, _Component);

  function ImageEditor(props) {
    _classCallCheck(this, ImageEditor);

    var _this = _possibleConstructorReturn(this, (ImageEditor.__proto__ || Object.getPrototypeOf(ImageEditor)).call(this, props));

    _this.getValue = function () {
      return _this.state.src;
    };

    _this.handlerMouseEnter = function () {
      _this.setState({
        showImageCover: true
      });
    };

    _this.handlerMouseLeave = function () {
      _this.setState({
        showImageCover: false
      });
    };

    _this.state = {
      show: false,
      img: null,
      src: _this.props.src,
      file: null,
      showImageCover: false
    };
    return _this;
  }

  _createClass(ImageEditor, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.src !== this.props.src) {
        this.state.src = nextProps.src;
      }
    }
  }, {
    key: 'handleClick',
    value: function handleClick() {
      this.setState({ show: true });
      (0, _sscAnalytics.tracker)('click', this.context.businessKey + '.update-image', this.context.componentName);
    }
  }, {
    key: 'imageChages',
    value: function imageChages(src) {
      this.setState({
        src: src
      });
    }
  }, {
    key: 'updateModalUrl',
    value: function updateModalUrl(newUrl) {
      this.refs.headImage.updateUrl(newUrl);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _state = this.state,
          show = _state.show,
          img = _state.img,
          src = _state.src,
          showImageCover = _state.showImageCover;
      var _props = this.props,
          className = _props.className,
          width = _props.width,
          height = _props.height,
          borderRadius = _props.borderRadius,
          readOnly = _props.readOnly,
          sizeLimit = _props.sizeLimit,
          uploadFile = _props.uploadFile;

      var imgProps = {
        className: className,
        width: width,
        height: height,
        style: { borderRadius: borderRadius + '%' },
        src: src
      };
      if (readOnly === true) {
        return _react2.default.createElement('img', imgProps);
      }
      var mouseProps = {
        onMouseEnter: this.handlerMouseEnter,
        onMouseLeave: this.handlerMouseLeave
      };
      var editDivStyle = showImageCover === true ? {} : { display: 'none' };
      return _jsx('div', {}, void 0, _jsx('div', {
        className: 'avatar-photo'
      }, void 0, _jsx('div', {
        className: 'avatar-edit',
        style: editDivStyle
      }, void 0, _react2.default.createElement('span', _extends({}, mouseProps, {
        onClick: this.handleClick.bind(this)
      })), _react2.default.createElement(
        'label',
        _extends({}, mouseProps, {
          onClick: this.handleClick.bind(this)
        }),
        '\u4FEE\u6539\u5934\u50CF'
      )), _react2.default.createElement('img', _extends({}, imgProps, mouseProps))), _react2.default.createElement(_HeadImage2.default, {
        ref: 'headImage',
        show: show,
        src: src,
        onChange: this.imageChages.bind(this),
        onHide: function onHide() {
          return _this2.setState({ show: false });
        },
        sizeLimit: sizeLimit,
        uploadFile: uploadFile
      }));
    }
  }]);

  return ImageEditor;
}(Component), _class.defaultProps = {
  width: 100,
  heigth: 100,
  borderRadius: 50,
  src: '/images/photo/0.png',
  readOnly: true,
  uploadFile: undefined,
  sizeLimit: 1024 * 10
}, _class.contextTypes = {
  businessKey: _propTypes2.default.string,
  componentName: _propTypes2.default.string
}, _temp);
exports.default = ImageEditor;