'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _switch = require('../switch');

var _switch2 = _interopRequireDefault(_switch);

var _span = require('../span');

var _span2 = _interopRequireDefault(_span);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _sscAnalytics = require('ssc-analytics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component;
var MakePublic = (_temp = _class = function (_Component) {
  _inherits(MakePublic, _Component);

  function MakePublic(props) {
    _classCallCheck(this, MakePublic);

    var _this = _possibleConstructorReturn(this, (MakePublic.__proto__ || Object.getPrototypeOf(MakePublic)).call(this, props));

    _this.getValue = function () {
      return _this.state.isPublic;
    };

    _this.state = {
      isPublic: _this.updateIsPublic(props.isPublic)
    };
    return _this;
  }

  _createClass(MakePublic, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (!(0, _isEqual2.default)(nextProps.isPublic, this.props.isPublic)) {
        var value = this.updateIsPublic(nextProps.isPublic);
        this.setState({ isPublic: value });
      }
    }
  }, {
    key: 'updateIsPublic',
    value: function updateIsPublic(value) {
      if (!(0, _isEqual2.default)(value, true) && !(0, _isEqual2.default)(value, false)) {
        return false;
      }
      return value;
    }
  }, {
    key: 'handleChange',
    value: function handleChange(value) {
      this.setState({
        isPublic: value
      });
      (0, _sscAnalytics.tracker)('click', this.context.businessKey + '.update-' + this.props.name, this.context.componentName);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          readOnly = _props.readOnly;
      var isPublic = this.state.isPublic;

      if (readOnly === true) {
        var text = isPublic ? publicTypes[isPublic] : '';
        var name = (0, _classnames2.default)([className, 'form-control-readonly-text']);
        return _jsx(_span2.default, {
          className: name
        }, void 0, text);
      }
      var props = {
        ref: 'switch',
        isOpen: isPublic,
        data: publicTypes,
        onChange: this.handleChange.bind(this)
      };
      return _react2.default.createElement(_switch2.default, props);
    }
  }]);

  return MakePublic;
}(Component), _class.defaultProps = {
  name: '',
  isPublic: false,
  readOnly: true
}, _class.contextTypes = {
  businessKey: _propTypes2.default.string,
  componentName: _propTypes2.default.string
}, _temp);


var publicTypes = {
  true: '公开',
  false: '公开'
};

exports.default = MakePublic;