'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _input = require('../input');

var _input2 = _interopRequireDefault(_input);

var _span = require('../span');

var _span2 = _interopRequireDefault(_span);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _sscAnalytics = require('ssc-analytics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component;
var RegInput = (_temp = _class = function (_Component) {
  _inherits(RegInput, _Component);

  function RegInput(props) {
    _classCallCheck(this, RegInput);

    var _this = _possibleConstructorReturn(this, (RegInput.__proto__ || Object.getPrototypeOf(RegInput)).call(this, props));

    _this.getValue = function () {
      (0, _sscAnalytics.tracker)('change', _this.context.businessKey + '.update-' + _this.props.type, _this.context.componentName);
      _this.handleBlur.call(_this);
      return _this.state.value;
    };

    _this.isVerified = function () {
      _this.handleBlur.call(_this);
      return !(0, _isEqual2.default)(_this.state.errorClass, 'error');
    };

    _this.state = {
      value: props.value,
      errorClass: ''
    };
    _this.regs = {
      number: /^[0-9]\d*$/,
      mobileNumber: /^[0-9]\d{0,10}$/,
      // mobile: /^1[34578]\d{9}$/,
      mobile: /^[0-9]\d{10}$/,
      email: /^[\w-]+(\.[\w-]+)*@[\w-]+(\.[\w-]+)+$/,
      telephoneNumber: /^[0-9]\d{0,25}$/,
      telephone: /(\(\d{3,4}\)|\d{3,4}-|\s)?\d{8}/,
      newTelephone: /^[0-9\-()（）/]{0,20}$/,
      name: /^[a-zA-Z\u4E00-\u9FA5]{1,10}$/,
      companyName: /^[a-zA-Z\u4E00-\u9FA5\s,.;:'"，。；：‘’“”()（）-]{1,30}$/
    };
    return _this;
  }

  _createClass(RegInput, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (!(0, _isEqual2.default)(nextProps.value, this.props.value)) {
        this.setState({ value: nextProps.value });
      }
    }
  }, {
    key: 'handleChange',
    value: function handleChange(val) {
      var value = this.state.value;

      var flag = true;
      if ((0, _isEqual2.default)(this.props.type, 'mobile')) {
        flag = this.regs.mobileNumber.test(val) || val === '';
      } else if ((0, _isEqual2.default)(this.props.type, 'telephone')) {
        flag = this.regs.newTelephone.test(val) || val === '';
      } else if ((0, _isEqual2.default)(this.props.type, 'name')) {
        flag = this.regs.name.test(val) || val === '';
      } else if ((0, _isEqual2.default)(this.props.type, 'companyName')) {
        flag = this.regs.companyName.test(val) || val === '';
      }
      this.setState({
        value: flag ? val : value,
        errorClass: ''
      });
    }
  }, {
    key: 'handleBlur',
    value: function handleBlur() {
      var value = this.state.value;

      var flag = true;
      if (!(0, _isNil2.default)(value) && !(0, _isEqual2.default)(value, '')) {
        if ((0, _isEqual2.default)(this.props.type, 'mobile')) {
          flag = this.regs.mobile.test(value);
        } else if ((0, _isEqual2.default)(this.props.type, 'email')) {
          flag = this.regs.email.test(value);
        } else if ((0, _isEqual2.default)(this.props.type, 'telephone')) {
          flag = this.regs.newTelephone.test(value);
        } else if ((0, _isEqual2.default)(this.props.type, 'name')) {
          flag = this.regs.name.test(value);
        } else if ((0, _isEqual2.default)(this.props.type, 'companyName')) {
          flag = this.regs.companyName.test(value);
        }
      } else {
        flag = !this.props.isRequire;
      }
      this.state.errorClass = flag ? '' : 'error';
      this.setState({});
    }
  }, {
    key: 'limitValueLength',
    value: function limitValueLength(value) {
      if ((0, _isEqual2.default)(this.props.type, 'telephone')) {
        return this.subString(value, 12);
      }
      return value;
    }
  }, {
    key: 'subString',
    value: function subString(str, limitedLength) {
      if ((0, _isNil2.default)(str) || (0, _isEqual2.default)(str, '')) {
        return '';
      }
      if (str.length > limitedLength) {
        return str.substr(0, limitedLength);
      }
      return str;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          readOnly = _props.readOnly,
          className = _props.className,
          isPublic = _props.isPublic;
      var _state = this.state,
          value = _state.value,
          errorClass = _state.errorClass;

      var name = (0, _classnames2.default)([errorClass, className, 'reg-input']);
      return readOnly ? isPublic ? _jsx(_span2.default, {
        className: name
      }, void 0, this.limitValueLength(value)) : _jsx(_span2.default, {
        className: name
      }) : _jsx(_input2.default, {
        className: name,
        value: (0, _isNil2.default)(value) ? '' : value,
        onChange: this.handleChange.bind(this),
        onBlur: this.handleBlur.bind(this)
      });
    }
  }]);

  return RegInput;
}(Component), _class.defaultProps = {
  value: '',
  isRequire: false,
  readOnly: false,
  isPublic: true
}, _class.contextTypes = {
  businessKey: _propTypes2.default.string,
  componentName: _propTypes2.default.string
}, _temp);
exports.default = RegInput;