'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _select = require('../select');

var _select2 = _interopRequireDefault(_select);

var _span = require('../span');

var _span2 = _interopRequireDefault(_span);

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component;
var SelectInput = (_temp = _class = function (_Component) {
  _inherits(SelectInput, _Component);

  function SelectInput(props) {
    _classCallCheck(this, SelectInput);

    var _this = _possibleConstructorReturn(this, (SelectInput.__proto__ || Object.getPrototypeOf(SelectInput)).call(this, props));

    _this.getValue = function () {
      var value = _this.state.value;

      _this.checkValue(value);
      return value;
    };

    _this.state = {
      value: _this.props.value,
      errorClass: ''
    };
    return _this;
  }

  _createClass(SelectInput, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (!(0, _isEqual2.default)(nextProps.value, this.props.value)) {
        this.setState({ value: nextProps.value });
      }
    }
  }, {
    key: 'handleChange',
    value: function handleChange(value) {
      this.checkValue(value);
      this.setState({
        value: value
      });
      var onChange = this.props.onChange;

      if ((0, _isFunction2.default)(onChange)) {
        onChange(value);
      }
    }
  }, {
    key: 'checkValue',
    value: function checkValue(value) {
      if (this.props.isRequire) {
        var flag = (0, _isEmpty2.default)(value) || (0, _isNil2.default)(value);
        this.setState({ errorClass: flag ? 'error' : '' });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          data = _props.data,
          readOnly = _props.readOnly;
      var _state = this.state,
          value = _state.value,
          errorClass = _state.errorClass;

      var name = (0, _classnames2.default)([className, errorClass]);
      if (readOnly === true) {
        var text = '';
        (0, _map2.default)(data, function (constellation) {
          if ((0, _isEqual2.default)(value, constellation.id)) {
            text = constellation.text;
          }
        });
        name = (0, _classnames2.default)([name, 'form-control-readonly-text']);
        return _jsx(_span2.default, {
          className: name
        }, void 0, text);
      }
      var props = {
        ref: 'select',
        className: name,
        value: value,
        data: data,
        onChange: this.handleChange.bind(this)
      };
      return _react2.default.createElement(_select2.default, props);
    }
  }]);

  return SelectInput;
}(Component), _class.defaultProps = {
  data: [],
  value: '',
  isRequire: false,
  readOnly: true
}, _temp);
exports.default = SelectInput;