'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _input = require('../input');

var _input2 = _interopRequireDefault(_input);

var _span = require('../span');

var _span2 = _interopRequireDefault(_span);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component;
var TextInput = (_temp = _class = function (_Component) {
  _inherits(TextInput, _Component);

  function TextInput(props) {
    _classCallCheck(this, TextInput);

    var _this = _possibleConstructorReturn(this, (TextInput.__proto__ || Object.getPrototypeOf(TextInput)).call(this, props));

    _this.getValue = function () {
      _this.handleBlur.call(_this);
      return _this.state.value;
    };

    _this.state = {
      value: props.value,
      errorClass: ''
    };
    return _this;
  }

  _createClass(TextInput, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (!(0, _isEqual2.default)(nextProps.value, this.state.value)) {
        this.setState({ value: nextProps.value });
      }
    }
  }, {
    key: 'handleChange',
    value: function handleChange(value) {
      this.setState({
        value: value,
        errorClass: ''
      });
      var onChange = this.props.onChange;

      if ((0, _isFunction2.default)(onChange)) {
        onChange(value);
      }
    }
  }, {
    key: 'handleBlur',
    value: function handleBlur() {
      if (this.props.isRequire) {
        var value = this.state.value;

        var flag = (0, _isEmpty2.default)(value) || (0, _isNil2.default)(value);
        this.setState({ errorClass: flag ? 'error' : '' });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          readOnly = _props.readOnly,
          showSpan = _props.showSpan,
          className = _props.className,
          type = _props.type,
          maxLength = _props.maxLength,
          placeholder = _props.placeholder,
          validMode = _props.validMode,
          isRequire = _props.isRequire;
      var _state = this.state,
          value = _state.value,
          errorClass = _state.errorClass;

      var name = (0, _classnames2.default)(className, _defineProperty({}, errorClass, isRequire));
      return readOnly && showSpan ? _jsx(_span2.default, {
        className: name
      }, void 0, value) : _jsx(_input2.default, {
        className: name,
        type: type,
        value: (0, _isNil2.default)(value) ? '' : value,
        readOnly: readOnly,
        onChange: this.handleChange.bind(this),
        onBlur: this.handleBlur.bind(this),
        maxLength: maxLength,
        placeholder: placeholder,
        validMode: validMode
      });
    }
  }]);

  return TextInput;
}(Component), _class.defaultProps = {
  value: '',
  isRequire: false,
  readOnly: false,
  showSpan: true
}, _temp);
exports.default = TextInput;