'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _textarea = require('../textarea');

var _textarea2 = _interopRequireDefault(_textarea);

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _isString = require('lodash/isString');

var _isString2 = _interopRequireDefault(_isString);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _span = require('../span');

var _span2 = _interopRequireDefault(_span);

var _sscAnalytics = require('ssc-analytics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextareaLimit = (_temp = _class = function (_React$Component) {
  _inherits(TextareaLimit, _React$Component);

  function TextareaLimit(props) {
    _classCallCheck(this, TextareaLimit);

    var _this = _possibleConstructorReturn(this, (TextareaLimit.__proto__ || Object.getPrototypeOf(TextareaLimit)).call(this, props));

    _this.getValue = function () {
      (0, _sscAnalytics.tracker)('change', _this.context.businessKey + '.update-autograph', _this.context.componentName);
      _this.handleTextareaBlur.call(_this);
      return _this.state.value;
    };

    _this.isVerified = function () {
      return !(0, _isEqual2.default)(_this.state.errorClass, 'error');
    };

    _this.handleTextareaChange = function (value) {
      _this.setState({
        value: value,
        errorClass: ''
      });
    };

    _this.handleTextareaBlur = function () {
      var textLengthAtLeast = _this.props.textLengthAtLeast;
      var value = _this.state.value;

      var length = value ? value.length : 0;
      var errorFlag = false;
      if (_this.props.isRequire) {
        var _value = _this.state.value;

        errorFlag = (0, _isEmpty2.default)(_value) || (0, _isNil2.default)(_value);
      }
      if (length > 0 && length < textLengthAtLeast) {
        errorFlag = true;
      }
      _this.setState({ errorClass: errorFlag ? 'error' : '' });
    };

    _this.state = {
      value: _this.initValue(_this.props.value),
      errorClass: ''
    };
    return _this;
  }

  _createClass(TextareaLimit, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps, nextState) {
      if (!(0, _isEqual2.default)(nextProps.value, this.props.value)) {
        var value = this.initValue(nextProps.value);
        this.setState({ value: value });
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var should = false;
      if (!(0, _isEqual2.default)(nextProps.value, this.props.value)) {
        should = true;
      }
      if (!(0, _isEqual2.default)(nextProps.readOnly, this.props.readOnly)) {
        should = true;
      }
      if (!(0, _isEqual2.default)(nextState.value, this.state.value)) {
        should = true;
      }
      if (!(0, _isEqual2.default)(nextState.errorClass, this.state.errorClass)) {
        should = true;
      }
      return should;
    }
  }, {
    key: 'initValue',
    value: function initValue(value) {
      if ((0, _isNil2.default)(value) || !(0, _isString2.default)(value)) {
        return '';
      }
      return value;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          textLength = _props.textLength,
          textLengthAtLeast = _props.textLengthAtLeast,
          maxLength = _props.maxLength,
          readOnly = _props.readOnly;
      var _state = this.state,
          value = _state.value,
          errorClass = _state.errorClass;

      if (readOnly) {
        var newClassName = (0, _classnames2.default)([className, 'form-control-readonly-text']);
        return _jsx(_span2.default, {
          className: newClassName
        }, void 0, value);
      }
      var name = (0, _classnames2.default)([errorClass, className]);
      var props = {
        className: name,
        maxLength: maxLength,
        value: value,
        onChange: this.handleTextareaChange,
        onBlur: this.handleTextareaBlur
      };
      var leftNumber = textLength - ((0, _isNil2.default)(value) ? 0 : value.length);
      return _jsx('div', {
        className: className
      }, void 0, _react2.default.createElement(_textarea2.default, props), _jsx('div', {
        className: 'value-limit-div'
      }, void 0, '\u8FD8\u53EF\u4EE5\u8F93\u5165', leftNumber, '\u5B57(\u4E0D\u5C11\u4E8E', textLengthAtLeast, '\u4E2A\u5B57)'));
    }
  }]);

  return TextareaLimit;
}(_react2.default.Component), _class.defaultProps = {
  textLength: 1000,
  textLengthAtLeast: 0,
  value: '',
  maxLength: 1000
}, _class.contextTypes = {
  businessKey: _propTypes2.default.string,
  componentName: _propTypes2.default.string
}, _temp);
exports.default = TextareaLimit;