'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _toString = require('lodash/toString');

var _toString2 = _interopRequireDefault(_toString);

var _toNumber = require('lodash/toNumber');

var _toNumber2 = _interopRequireDefault(_toNumber);

var _reactGridLayout = require('react-grid-layout');

var _reactGridLayout2 = _interopRequireDefault(_reactGridLayout);

var _ResizeWidget = require('./ResizeWidget');

var _ResizeWidget2 = _interopRequireDefault(_ResizeWidget);

var _reactDom = require('react-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GridLayout = (0, _reactGridLayout.WidthProvider)(_reactGridLayout2.default);

var Component = _react2.default.Component,
    Children = _react2.default.Children;
var Grid = (_temp = _class = function (_Component) {
  _inherits(Grid, _Component);

  function Grid(props) {
    _classCallCheck(this, Grid);

    var _this = _possibleConstructorReturn(this, (Grid.__proto__ || Object.getPrototypeOf(Grid)).call(this, props));

    _initialiseProps.call(_this);

    _this.state = {
      rowHeight: 150,
      height: 0
    };
    _this.isCalcHeight = false;
    return _this;
  }

  _createClass(Grid, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var should = false;
      if (!(0, _isEqual2.default)(nextProps.itemWidth, this.props.itemWidth)) {
        should = true;
      }
      if (!(0, _isEqual2.default)(nextProps.itemHeight, this.props.itemHeight)) {
        should = true;
      }
      if (!(0, _isEqual2.default)(nextProps.layout, this.props.layout)) {
        should = true;
      }
      if (!(0, _isEqual2.default)(nextState.rowHeight, this.state.rowHeight)) {
        should = true;
      }
      if (!(0, _isEqual2.default)(nextProps.children, this.props.children)) {
        should = true;
      }
      return should;
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var domNode = (0, _reactDom.findDOMNode)(this.refs.widget);
      if (!(0, _isNil2.default)(domNode)) {
        var rect = domNode.getBoundingClientRect();
        this.handleResize(rect);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _ResizeWidget2.default,
        { ref: 'widget', onResize: this.handleResize },
        this.isCalcHeight ? this.renderGrid() : ''
      );
    }
  }]);

  return Grid;
}(Component), _class.defaultProps = {
  isDraggable: true,
  useCSSTransforms: false,
  autoSize: true,
  isResizable: true,
  cols: 12,
  rows: 12,
  itemWidth: 12,
  itemHeight: 12,
  draggableHandle: '',
  layout: null
}, _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.layout = function (layout, cols, rows, width, height) {
    if (!(0, _isNil2.default)(layout)) {
      return layout;
    }
    var children = _this2.props.children;

    var bx = 0;
    var xBak = 0;
    var count = parseInt(cols / width);
    return Children.map(children, function (child, index) {
      var x = void 0;
      if (xBak + 1 > count) {
        x = 1;
        bx = bx + 1;
      } else {
        x = xBak + 1;
      }
      xBak = x;
      // return {i: 'item-' + index, x: (x - 1) * width, y: bx, w: width, h: height}
      return { i: (0, _toString2.default)(index), x: (x - 1) * width, y: bx, w: width, h: height };
    });
  };

  this.handleResize = function (size) {
    var _props = _this2.props,
        onResize = _props.onResize,
        rows = _props.rows,
        onChildResize = _props.onChildResize;

    var height = size.height / rows;
    if (!(0, _isEqual2.default)(height, _this2.state.rowHeight)) {
      _this2.setState({ rowHeight: height - 1 });
    }
    _this2.isCalcHeight = true;
    if ((0, _isFunction2.default)(onResize)) {
      onResize(size);
    }
    if ((0, _isFunction2.default)(onChildResize)) {
      onChildResize();
    }
  };

  this.renderChildren = function (children) {
    var _props2 = _this2.props,
        layout = _props2.layout,
        cols = _props2.cols,
        rows = _props2.rows,
        itemWidth = _props2.itemWidth,
        itemHeight = _props2.itemHeight;

    var g = _this2.layout(layout, cols, rows, itemWidth, itemHeight);
    var data = [];
    Children.map(children, function (child, index) {
      var ele = _jsx('div', {
        style: { display: 'flex' }
      }, g[index].i, child);
      data.push(ele);
    });
    return data;
  };

  this.renderGrid = function () {
    var _props3 = _this2.props,
        children = _props3.children,
        className = _props3.className,
        layout = _props3.layout,
        cols = _props3.cols,
        rows = _props3.rows,
        itemWidth = _props3.itemWidth,
        itemHeight = _props3.itemHeight,
        other = _objectWithoutProperties(_props3, ['children', 'className', 'layout', 'cols', 'rows', 'itemWidth', 'itemHeight']);

    var props = {
      className: (0, _classnames2.default)(['grid-layout', className]),
      rowHeight: _this2.state.rowHeight,
      margin: [0, 0],
      layout: _this2.layout(layout, cols, rows, itemWidth, itemHeight),
      onResizeStop: function onResizeStop(layouts, pre, chg) {
        var onChildResize = _this2.props.onChildResize;

        if ((0, _isFunction2.default)(onChildResize)) {
          onChildResize((0, _toNumber2.default)(chg.i));
        }
      }
    };
    delete other.onResize;
    return _react2.default.createElement(
      GridLayout,
      _extends({ ref: 'gridLayout' }, props, other),
      _this2.renderChildren(children)
    );
  };
}, _temp);
exports.default = Grid;