'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp; /**
                    * Copyright @2016 www.sumscope.com
                    */

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _input = require('../input');

var _input2 = _interopRequireDefault(_input);

var _modal = require('../modal');

var _modal2 = _interopRequireDefault(_modal);

var _switch = require('../switch');

var _switch2 = _interopRequireDefault(_switch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ImportEditorModal = (_temp = _class = function (_React$Component) {
  _inherits(ImportEditorModal, _React$Component);

  function ImportEditorModal(props) {
    _classCallCheck(this, ImportEditorModal);

    var _this = _possibleConstructorReturn(this, (ImportEditorModal.__proto__ || Object.getPrototypeOf(ImportEditorModal)).call(this, props));

    _this.state = {
      isShown: props.isShown,
      importData: props.importData
    };
    _this.handleTrash = _this.handleTrash.bind(_this);
    _this.handleConfirm = _this.handleConfirm.bind(_this);
    _this.handleClose = _this.handleClose.bind(_this);
    return _this;
  }

  _createClass(ImportEditorModal, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({
        isShown: nextProps.isShown,
        importData: nextProps.importData
      });
    }
  }, {
    key: 'getImportData',
    value: function getImportData() {
      var _this2 = this;

      var columnInfo = this.props.columnInfo;
      var importData = this.state.importData;

      var importDataNew = [];
      importData.map(function (data, rowNum) {
        var dataNew = {};
        columnInfo.map(function (item, colNum) {
          var ref = 'itemRow' + rowNum + 'Col' + colNum;
          switch (item.type) {
            case 'INPUT':
              dataNew[item.key] = _this2.refs[ref].getValue();
              break;
            case 'SWITCH':
              dataNew[item.key] = _this2.refs[ref].isOpen();
              break;
            case 'FUNC':
              dataNew[item.key] = item.getValue(_this2.refs[ref]);
              break;
          }
        });
        importDataNew.push(dataNew);
      });
      return importDataNew;
    }
  }, {
    key: 'handleTrash',
    value: function handleTrash(index) {
      var importDataOld = this.state.importData;

      var importData = this.getImportData();
      importData.map(function (item, index) {
        if (!(0, _isNil2.default)(importDataOld[index].errorMsg)) {
          item.errorMsg = importDataOld[index].errorMsg;
        }
      });
      importData.splice(index, 1);
      if ((0, _isEmpty2.default)(importData)) {
        var columnInfo = this.props.columnInfo;

        var data = {};
        columnInfo.map(function (item) {
          data[item.key] = item.defaultValue;
        });
        importData.push(data);
      }
      this.setState(_extends({}, this.state, { importData: importData }));
    }
  }, {
    key: 'handleConfirm',
    value: function handleConfirm() {
      var onConfirm = this.props.onConfirm;

      var importData = this.getImportData();
      if ((0, _isFunction2.default)(onConfirm)) {
        onConfirm(importData);
      }
    }
  }, {
    key: 'handleClose',
    value: function handleClose() {
      var onClose = this.props.onClose;

      if ((0, _isFunction2.default)(onClose)) {
        onClose();
      } else {
        this.setState(_extends({}, this.state, { isShown: false }));
      }
    }
  }, {
    key: 'changeInput',
    value: function changeInput(rowData, key, value) {
      rowData.errorMsg[key] = undefined;
      rowData[key] = value;
      this.forceUpdate();
    }
  }, {
    key: 'renderHeader',
    value: function renderHeader() {
      var columnInfo = this.props.columnInfo;

      return columnInfo.map(function (item, colNum) {
        var headerStyle = _extends({}, item.style, {
          width: item.width
        });
        return _jsx('span', {
          className: 'header-cell',
          style: headerStyle
        }, 'header-' + colNum, item.name);
      });
    }
  }, {
    key: 'renderBody',
    value: function renderBody() {
      var _this3 = this;

      var columnInfo = this.props.columnInfo;
      var importData = this.state.importData;

      return importData.map(function (rowData, rowNum) {
        return _jsx('div', {
          className: 'body-row'
        }, 'body-' + rowNum, _this3.renderRow(rowData, columnInfo, rowNum), _jsx('span', {
          className: 'body-cell',
          style: { width: 50 }
        }, void 0, _jsx('img', {
          src: '/images/trash.png',
          onClick: function onClick() {
            _this3.handleTrash(rowNum);
          },
          style: { cursor: 'pointer' }
        })));
      });
    }
  }, {
    key: 'renderRow',
    value: function renderRow(rowData, columnInfo, rowNum) {
      var _this4 = this;

      return columnInfo.map(function (item, colNum) {
        var rowStyle = {
          width: item.width
        };
        var className = 'body-cell';
        if (!(0, _isEmpty2.default)(rowData.errorMsg)) {
          className = (0, _classnames2.default)(className, 'error');
        }
        return _jsx('span', {
          className: className,
          style: rowStyle
        }, 'body-' + rowNum + '-' + colNum, _this4.renderItem(rowData, item, rowNum, colNum), _this4.renderItemErrorMessage(rowData, item));
      });
    }
  }, {
    key: 'renderItem',
    value: function renderItem(rowData, columnInfo, rowNum, colNum) {
      var ref = 'itemRow' + rowNum + 'Col' + colNum;
      var errorFlag = false;
      if (!(0, _isEmpty2.default)(rowData.errorMsg) && !(0, _isNil2.default)(rowData.errorMsg[columnInfo.key])) {
        errorFlag = true;
      }
      switch (columnInfo.type) {
        case 'INPUT':
          var className = errorFlag ? 'error' : '';
          return _react2.default.createElement(_input2.default, { value: rowData[columnInfo.key], onChange: this.changeInput.bind(this, rowData, columnInfo.key), className: className, ref: ref, placeholder: ' ' });
        case 'SWITCH':
          return _react2.default.createElement(_switch2.default, { isOpen: rowData[columnInfo.key], ref: ref });
        case 'FUNC':
          return columnInfo.render(rowData[columnInfo.key], ref);
      }
    }
  }, {
    key: 'renderItemErrorMessage',
    value: function renderItemErrorMessage(rowData, columnInfo) {
      if (!(0, _isEmpty2.default)(rowData.errorMsg) && !(0, _isNil2.default)(rowData.errorMsg[columnInfo.key])) {
        return _jsx('span', {
          className: 'body-cell-error-message'
        }, void 0, rowData.errorMsg[columnInfo.key]);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          title = _props.title,
          width = _props.width,
          dataHeight = _props.dataHeight;
      var isShown = this.state.isShown;

      var props = {
        isShown: isShown,
        className: className,
        header: title,
        width: width,
        onClose: this.handleClose,
        buttons: {
          'CONFIRM': this.handleConfirm,
          'CANCEL': true
        }
      };
      var dataStyle = {
        maxHeight: dataHeight
      };
      return _react2.default.createElement(
        _modal2.default,
        props,
        _jsx('div', {
          className: 'import-editor'
        }, void 0, _jsx('div', {
          className: 'header'
        }, void 0, this.renderHeader(), _jsx('span', {
          className: 'header-cell',
          style: { width: 50 }
        }, void 0, '\u64CD\u4F5C')), _jsx('div', {
          className: 'content',
          style: dataStyle
        }, void 0, _jsx('div', {
          className: 'body'
        }, void 0, this.renderBody())))
      );
    }
  }]);

  return ImportEditorModal;
}(_react2.default.Component), _class.defaultProps = {
  isShown: false,
  importData: [],
  title: '导入',
  width: 600,
  dataHeight: 450
}, _temp);
exports.default = ImportEditorModal;