'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _StringUtils = require('../../utils/StringUtils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Input = (_temp = _class = function (_React$Component) {
  _inherits(Input, _React$Component);

  function Input(props) {
    _classCallCheck(this, Input);

    var _this = _possibleConstructorReturn(this, (Input.__proto__ || Object.getPrototypeOf(Input)).call(this, props));

    _this.getValue = function () {
      return _this.state.value;
    };

    _this.state = {
      value: props.value
    };
    _this.handleChange = _this.handleChange.bind(_this);
    return _this;
  }

  _createClass(Input, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var value = nextProps.value;
      this.setState({ value: value });
    }
  }, {
    key: 'handleChange',
    value: function handleChange(event) {
      var _props = this.props,
          readOnly = _props.readOnly,
          onChange = _props.onChange,
          validMode = _props.validMode;

      if (readOnly) {
        return;
      }

      var value = (0, _StringUtils.filterEmoji)(event.target.value);
      var isValid = true;
      var validObj = void 0;
      if (validMode) {
        validObj = validMode(value);
        isValid = validObj.isValid;
      }

      if (isValid) {
        if (validObj) {
          value = validObj.value;
        }
        if ((0, _isFunction2.default)(onChange)) {
          onChange(value);
        }
      } else {
        value = this.state.value;
      }
      this.setState({ value: value });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          className = _props2.className,
          type = _props2.type,
          autoFocus = _props2.autoFocus,
          other = _objectWithoutProperties(_props2, ['className', 'type', 'autoFocus']);

      var props = {
        className: (0, _classnames2.default)('input', className),
        type: type === 'password' ? 'password' : 'text',
        onChange: this.handleChange,
        value: this.state.value,
        autoFocus: autoFocus
      };
      delete other.validMode;
      return _react2.default.createElement('input', _extends({}, other, props));
    }
  }]);

  return Input;
}(_react2.default.Component), _class.defaultProps = {
  value: '',
  autoFocus: false
}, _temp);
exports.default = Input;