'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _class, _temp;

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _dom = require('../../utils/dom');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright @2016 www.sumscope.com
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var ListContainer = function (_React$Component) {
  _inherits(ListContainer, _React$Component);

  function ListContainer() {
    _classCallCheck(this, ListContainer);

    return _possibleConstructorReturn(this, (ListContainer.__proto__ || Object.getPrototypeOf(ListContainer)).apply(this, arguments));
  }

  _createClass(ListContainer, [{
    key: 'close',
    value: function close() {
      var close = this.props.close;

      if (typeof close === 'function') {
        close();
      }
    }
  }, {
    key: 'selectList',
    value: function selectList(id) {
      var selected = this.props.selected;

      if (typeof selected === 'function') {
        selected(id);
      }
    }
  }, {
    key: 'renderList',
    value: function renderList() {
      var _this2 = this;

      var data = this.props.data;

      var lis = data.map(function (item) {
        return _jsx('li', {
          onClick: _this2.selectList.bind(_this2, item.id)
        }, item.id, item.text);
      });
      return _jsx('ul', {}, void 0, lis);
    }
  }, {
    key: 'renderInner',
    value: function renderInner() {
      var _props = this.props,
          isOverFlow = _props.isOverFlow,
          parentRect = _props.parentRect,
          width = _props.width,
          height = _props.height;


      var style = {
        width: width,
        maxHeight: height
      };

      if (isOverFlow.x) {
        style.left = parentRect.left + parentRect.width - width;
      } else {
        style.left = parentRect.left;
      }

      if (isOverFlow.y) {
        style.bottom = (0, _dom.getWindowSize)().height - parentRect.top + 1;
      } else {
        style.top = parentRect.top + parentRect.height + 1;
      }

      return _react2.default.createElement(
        'div',
        { className: 'list-inner', style: style, ref: 'inner' },
        this.renderList.call(this)
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var isShown = this.props.isShown;

      return _jsx('div', {
        className: (0, _classnames2.default)('list-wrap', { hidden: !isShown }),
        onClick: this.close.bind(this)
      }, void 0, isShown ? this.renderInner.call(this) : '');
    }
  }]);

  return ListContainer;
}(_react2.default.Component);

var List = (_temp = _class = function (_React$Component2) {
  _inherits(List, _React$Component2);

  function List(props) {
    _classCallCheck(this, List);

    var _this3 = _possibleConstructorReturn(this, (List.__proto__ || Object.getPrototypeOf(List)).call(this, props));

    _this3.state = {
      isShown: props.isShown,
      value: _this3.getData.call(_this3)
    };
    return _this3;
  }

  _createClass(List, [{
    key: 'handleClick',
    value: function handleClick(e) {
      var _props2 = this.props,
          width = _props2.width,
          height = _props2.height,
          data = _props2.data,
          readOnly = _props2.readOnly;

      if (readOnly) {
        return;
      }
      e = e || window.event;
      var target = e.target;
      var parentRect = (0, _dom.getPosElement)(target);
      var overFlow = (0, _dom.isOverFlow)(target, width, height);
      var isShown = !this.state.isShown;
      this.state.isShown = isShown;

      if (!(0, _dom.isExistedListContainer)()) {
        (0, _dom.createListContainer)();
      }

      var props = {
        isOverFlow: overFlow,
        parentRect: parentRect,
        width: width,
        height: height,
        data: data,
        isShown: isShown,
        close: this.closeList.bind(this),
        selected: this.getSelected.bind(this)
      };

      _reactDom2.default.render(_react2.default.createElement(ListContainer, props), _dom.listContainer);
      e.stopPropagation();
    }
  }, {
    key: 'closeList',
    value: function closeList() {
      this.state.isShown = false;
      var props = {
        isShown: false
      };
      _reactDom2.default.render(_react2.default.createElement(ListContainer, props), _dom.listContainer);
    }
  }, {
    key: 'getSelected',
    value: function getSelected(id) {
      this.formatData.call(this, id);
      this.state.value = id;
      this.setState({ isShown: false });

      var onChange = this.props.onChange;

      if (typeof onChange === 'function') {
        onChange(id);
      }
    }
  }, {
    key: 'getValue',
    value: function getValue() {
      return this.state.value;
    }
  }, {
    key: 'formatData',
    value: function formatData(id) {
      var data = this.props.data;

      data.map(function (item) {
        item.isChecked = item.id === id;
      });
    }
  }, {
    key: 'getData',
    value: function getData() {
      var v = '';
      var data = this.props.data;

      data.map(function (item) {
        if (item.isChecked) {
          v = item.id;
        }
      });
      return v;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var _props3 = this.props,
          className = _props3.className,
          data = _props3.data,
          style = _props3.style;


      var listChecked = data.map(function (item) {
        if (item.isChecked) {
          return _jsx('span', {
            className: 'list-checked',
            onClick: _this4.handleClick.bind(_this4)
          }, item.id, item.text);
        }
      });

      return _jsx('div', {
        className: (0, _classnames2.default)('list', className),
        style: style
      }, void 0, listChecked);
    }
  }]);

  return List;
}(_react2.default.Component), _class.defaultProps = {
  width: 40,
  height: 50,
  isShown: false,
  readOnly: false,
  data: [{ id: 'plus', text: '+', isChecked: true }, { id: 'minus', text: '-', isChecked: false }]
}, _temp);
exports.default = List;