'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _class, _temp;

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _cover = require('../cover');

var _dom = require('../../utils/dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright @2016 www.sumscope.com
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var LoaderCover = function (_React$Component) {
  _inherits(LoaderCover, _React$Component);

  function LoaderCover() {
    _classCallCheck(this, LoaderCover);

    return _possibleConstructorReturn(this, (LoaderCover.__proto__ || Object.getPrototypeOf(LoaderCover)).apply(this, arguments));
  }

  _createClass(LoaderCover, [{
    key: 'render',
    value: function render() {
      var isShown = this.props.isShown;

      return _jsx('div', {}, void 0, isShown ? _jsx(_cover.Cover, {
        show: true,
        type: 'modal',
        content: '',
        style: { backgroundColor: '#000', opacity: 0.3 }
      }) : '');
    }
  }]);

  return LoaderCover;
}(_react2.default.Component);

var Loader = (_temp = _class = function (_React$Component2) {
  _inherits(Loader, _React$Component2);

  function Loader(props) {
    _classCallCheck(this, Loader);

    var _this2 = _possibleConstructorReturn(this, (Loader.__proto__ || Object.getPrototypeOf(Loader)).call(this, props));

    _this2.state = {
      isShown: props.isShown
    };
    return _this2;
  }

  _createClass(Loader, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      var isRender = false;
      if (nextProps.isShown !== this.state.isShown) {
        this.state.isShown = nextProps.isShown;
        isRender = true;
      }
      return isRender;
    }
  }, {
    key: 'close',
    value: function close() {
      this.setState({ isShown: false });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var parentNode = this.refs.container.parentNode;
      var position = window.getComputedStyle(parentNode, null).getPropertyValue('position');
      if (position === 'static') {
        parentNode.style.position = 'relative';
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.isRenderCover.call(this);
    }
  }, {
    key: 'isRenderCover',
    value: function isRenderCover() {
      var isModal = this.props.isModal;

      if (isModal) {
        this.renderCover.call(this);
      }
    }
  }, {
    key: 'renderCover',
    value: function renderCover() {
      var isShown = this.state.isShown;

      if (!(0, _dom.isExistedListContainer)()) {
        (0, _dom.createListContainer)();
      }
      _reactDom2.default.render(_jsx(LoaderCover, {
        isShown: isShown
      }), _dom.listContainer);
    }
  }, {
    key: 'renderInner',
    value: function renderInner() {
      var _props = this.props,
          size = _props.size,
          color = _props.color;

      return _jsx('div', {
        className: 'ball-spin-fade-loader'
      }, void 0, _jsx('i', {
        className: 'icon-font icon-load',
        style: { fontSize: size, color: color }
      }));
    }
  }, {
    key: 'render',
    value: function render() {
      var isShown = this.state.isShown;

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('loader', { hidden: !isShown }), ref: 'container' },
        isShown ? this.renderInner.call(this) : ''
      );
    }
  }]);

  return Loader;
}(_react2.default.Component), _class.defaultProps = {
  isShown: false,
  isModal: false,
  size: 50,
  color: '#ffffff'
}, _temp);
exports.default = Loader;