'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcNotification = require('rc-notification');

var _rcNotification2 = _interopRequireDefault(_rcNotification);

var _icon = require('../icon');

var _icon2 = _interopRequireDefault(_icon);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _button = require('../button');

var _button2 = _interopRequireDefault(_button);

var _buttons = require('../buttons');

var _buttons2 = _interopRequireDefault(_buttons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Message = function () {
  function Message() {
    _classCallCheck(this, Message);

    this.defaultDuration = 2.5;
    this.key = 1;
    this.prefixCls = 'coms-message';
    this.messageInstance = _rcNotification2.default.newInstance({
      prefixCls: this.prefixCls,
      transitionName: 'move-up',
      style: {
        top: '6%',
        left: '50%'
      }
    });
  }

  _createClass(Message, [{
    key: 'getIconClass',
    value: function getIconClass(type) {
      switch (type) {
        case 'success':
          return 'icon-check';
        case 'info':
          return 'icon-info';
        case 'warning':
          return 'icon-warn';
        case 'error':
          return 'icon-error';
        case 'confirm':
          return 'icon-ask';
      }
    }
  }, {
    key: 'onClickBtn',
    value: function onClickBtn(key, btn, onClose) {
      this.messageInstance.removeNotice(key);
      if ((0, _isFunction2.default)(onClose)) {
        onClose(btn);
      }
    }
  }, {
    key: 'notice',
    value: function notice(content, duration, type, _onClose) {
      var _this = this;

      var key = this.key++;
      this.messageInstance.notice({
        key: key,
        duration: duration,
        content: _jsx('div', {
          className: this.prefixCls + '-' + type
        }, void 0, _jsx(_icon2.default, {
          className: this.getIconClass(type)
        }), _jsx('span', {}, void 0, content), type === 'confirm' ? _jsx(_buttons2.default, {}, void 0, _jsx(_button2.default, {
          onClick: this.onClickBtn.bind(this, key, 'ok', _onClose)
        }, void 0, '\u786E\u8BA4'), _jsx(_button2.default, {
          onClick: this.onClickBtn.bind(this, key, 'cancel', _onClose),
          className: 'btn-danger'
        }, void 0, '\u53D6\u6D88')) : ''),
        onClose: function onClose() {
          _this.messageInstance.removeNotice(key);
          if ((0, _isFunction2.default)(_onClose)) {
            _onClose();
          }
        }
      });
    }
  }, {
    key: 'settings',
    value: function settings(option) {
      // 配置气泡弹窗示例：
      // Message.settings({
      //   prefixCls: 'coms-message', [气泡根元素样式前缀]
      //   duration: 2.5, [气泡停留时间]
      //   transitionName: 'move-up', [气泡动画样式前缀]
      //   style: { [气泡样式]
      //     top: '4.25%',
      //     left: '50%'
      //   }
      // });
      this.defaultDuration = option.duration || this.defaultDuration;
      this.messageInstance = _rcNotification2.default.newInstance(option);
    }
  }, {
    key: 'info',
    value: function info(content, onClose) {
      this.notice(content, this.defaultDuration, 'info', onClose);
    }
  }, {
    key: 'success',
    value: function success(content, onClose) {
      this.notice(content, this.defaultDuration, 'success', onClose);
    }
  }, {
    key: 'warning',
    value: function warning(content, onClose) {
      this.notice(content, this.defaultDuration, 'warning', onClose);
    }
  }, {
    key: 'error',
    value: function error(content, onClose) {
      this.notice(content, this.defaultDuration, 'error', onClose);
    }
  }, {
    key: 'confirm',
    value: function confirm(content, onClose) {
      this.notice(content, null, 'confirm', onClose);
    }
  }]);

  return Message;
}();

;

exports.default = new Message();