'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MODAL_MOVE = undefined;

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _button = require('../button');

var _button2 = _interopRequireDefault(_button);

var _buttons = require('../buttons');

var _buttons2 = _interopRequireDefault(_buttons);

var _cover = require('../cover');

var _dom = require('../../utils/dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TRANSLATOR = {
  CANCEL: { text: '取消', type: 'grey' },
  CUSTOM_CANCEL: { text: '取消', type: 'grey' },
  CONFIRM: { text: '确定' },
  EDIT_TAG: { text: '编辑标签' },
  APPLY: { text: '应用' },
  SEND: { text: '发送' },
  IMPORT: { text: '导入' },
  RESET: { text: '重置', type: 'danger' }
};

var MODAL_MOVE = exports.MODAL_MOVE = {
  deltaX: 0,
  deltaY: 0,
  moveX: {
    min: 0,
    max: 0
  },
  moveY: {
    min: 0,
    max: 0
  },
  target: null,
  setTarget: function setTarget(node) {
    MODAL_MOVE.target = node;
  },
  setParam: function setParam(e) {
    var mousePos = MODAL_MOVE.getMousePos(e);
    var targetPos = MODAL_MOVE.target.getBoundingClientRect();

    MODAL_MOVE.deltaX = mousePos.left - targetPos.left;
    MODAL_MOVE.deltaY = mousePos.top - targetPos.top;
    MODAL_MOVE.moveX.min = 0;
    MODAL_MOVE.moveX.max = (0, _dom.getWindowSize)().width - targetPos.width;
    MODAL_MOVE.moveY.min = 0;
    MODAL_MOVE.moveY.max = (0, _dom.getWindowSize)().height - targetPos.height;
  },
  getMousePos: function getMousePos(e) {
    return {
      left: e.clientX,
      top: e.clientY
    };
  },
  init: function init(e) {
    MODAL_MOVE.setParam(e);
    document.onselectstart = function () {
      return false;
    };
    document.onmousemove = MODAL_MOVE.move;
    document.onmouseup = MODAL_MOVE.stop;
  },
  move: function move(e) {
    var mousePos = MODAL_MOVE.getMousePos(e);
    var top = mousePos.top - MODAL_MOVE.deltaY;
    var left = mousePos.left - MODAL_MOVE.deltaX;

    if (top < MODAL_MOVE.moveY.min) {
      top = MODAL_MOVE.moveY.min;
    } else if (top > MODAL_MOVE.moveY.max) {
      top = MODAL_MOVE.moveY.max;
    }

    if (left < MODAL_MOVE.moveX.min) {
      left = MODAL_MOVE.moveX.min;
    } else if (left > MODAL_MOVE.moveX.max) {
      left = MODAL_MOVE.moveX.max;
    }

    MODAL_MOVE.target.style.top = top + 'px';
    MODAL_MOVE.target.style.left = left + 'px';
    MODAL_MOVE.target.style.marginLeft = '0px';
  },
  stop: function stop() {
    document.onselectstart = null;
    document.onmousemove = null;
    document.onmouseup = null;
  }
};

var Modal = (_temp = _class = function (_React$Component) {
  _inherits(Modal, _React$Component);

  function Modal(props) {
    _classCallCheck(this, Modal);

    var _this = _possibleConstructorReturn(this, (Modal.__proto__ || Object.getPrototypeOf(Modal)).call(this, props));

    _this.state = {
      isShown: props.isShown
    };
    _this.close = _this.close.bind(_this);
    return _this;
  }

  _createClass(Modal, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var isShown = nextProps.isShown;
      this.setState({ isShown: isShown });
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.setDrag();
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setDrag();
    }
  }, {
    key: 'setDrag',
    value: function setDrag() {
      var _props = this.props,
          isDragged = _props.isDragged,
          isShown = _props.isShown;

      if (isDragged && isShown) {
        var header = this.refs.header;
        MODAL_MOVE.setTarget(this.refs.modal);
        header.style.cursor = 'move';
        header.onmousedown = MODAL_MOVE.init;
      }
    }
  }, {
    key: 'close',
    value: function close() {
      var onClose = this.props.onClose;

      if ((0, _isFunction2.default)(this.props.onModalState)) {
        this.props.onModalState(false);
      }
      if (typeof onClose === 'function') {
        onClose();
      }
    }
  }, {
    key: 'getClasses',
    value: function getClasses() {
      return this.state.isShown ? 'modal-cover active' : 'modal-cover';
    }
  }, {
    key: 'onHandle',
    value: function onHandle(buttons, type) {
      if (type === 'CANCEL') {
        this.close();
      } else {
        if (type === 'CONFIRM') {
          if (this.props.onConfirm && (0, _isFunction2.default)(this.props.onConfirm)) {
            if (!this.props.onConfirm()) {
              return;
            }
          }
        }

        if ((0, _isFunction2.default)(buttons[type]) ? buttons[type]() : false) {
          this.close();
        }
      }
    }
  }, {
    key: 'renderModal',
    value: function renderModal() {
      var _this2 = this;

      var _props2 = this.props,
          width = _props2.width,
          header = _props2.header,
          children = _props2.children,
          buttons = _props2.buttons,
          className = _props2.className;

      var modalProps = {
        ref: 'modal',
        className: (0, _classnames2.default)('modal fadein', className),
        style: {
          width: width,
          marginLeft: -1 * Math.floor(width / 2)
        }
      };

      var btns = [];
      if (buttons instanceof Array) {
        buttons.map(function (btn, i) {
          btns.push(_react2.default.createElement(
            _button2.default,
            _extends({ key: i }, btn),
            btn.name
          ));
        });
      } else {
        Object.keys(buttons).map(function (type, i) {
          var button = TRANSLATOR[type];
          btns.push(_jsx(_button2.default, {
            onClick: _this2.onHandle.bind(_this2, buttons, type),
            type: button.type || 'primary'
          }, i, button.text));
        });
      }

      return _react2.default.createElement(
        'div',
        modalProps,
        _jsx('i', {
          className: 'icon-font icon-close',
          onClick: this.close.bind(this)
        }),
        _react2.default.createElement(
          'div',
          { className: 'modal-header', ref: 'header' },
          header
        ),
        _jsx('div', {
          className: 'modal-content'
        }, void 0, children),
        _jsx('div', {
          className: 'modal-footer'
        }, void 0, _jsx(_buttons2.default, {}, void 0, btns))
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var isClickAway = this.props.isClickAway;

      return _jsx(_cover.Cover, {
        type: 'modal',
        show: this.state.isShown,
        opacity: 1,
        onClick: isClickAway ? this.close : undefined,
        content: this.state.isShown ? this.renderModal() : ''
      });
    }
  }]);

  return Modal;
}(_react2.default.Component), _class.defaultProps = {
  isClickAway: false,
  isShown: false,
  width: 500,
  header: '自定义标题',
  buttons: {
    'CONFIRM': function CONFIRM() {
      return true;
    },
    'CANCEL': true
  },
  isDragged: false
}, _temp);


Modal.MODAL_MOVE = MODAL_MOVE;

exports.default = Modal;