'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _input = require('../input');

var _input2 = _interopRequireDefault(_input);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _toNumber = require('lodash/toNumber');

var _toNumber2 = _interopRequireDefault(_toNumber);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DefaultValidModeReg = new RegExp('^[0-9]*$');

var _ref = _jsx('i', {
  className: 'icon-font icon-up'
});

var _ref2 = _jsx('i', {
  className: 'icon-font icon-down'
});

var NumberSelect = (_temp = _class = function (_Component) {
  _inherits(NumberSelect, _Component);

  // static contextTypes = {
  //   businessKey: PropTypes.string,
  //   componentName: PropTypes.string
  // };

  function NumberSelect(props) {
    _classCallCheck(this, NumberSelect);

    var _this = _possibleConstructorReturn(this, (NumberSelect.__proto__ || Object.getPrototypeOf(NumberSelect)).call(this, props));

    var value = _this.props.value;

    _this.state = {
      value: value,
      valid: _this.checkValue(value).valid
    };
    return _this;
  }

  _createClass(NumberSelect, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var value = nextProps.value;

      if (!(0, _isEqual2.default)(value, this.props.value)) {
        this.setState({ value: value, valid: this.checkValue(value).valid });
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      // if (!isEqual(nextState.value, this.state.value)) {
      //   return true;
      // }
      // if (!isEqual(nextState.valid, this.state.valid)) {
      //   return true;
      // }
      return true;
    }
  }, {
    key: 'getValue',
    value: function getValue() {
      return this.state.value;
    }
  }, {
    key: 'handleChange',
    value: function handleChange(value) {
      var onChange = this.props.onChange;

      value = (0, _toNumber2.default)(value);

      var _checkValue = this.checkValue(value),
          valid = _checkValue.valid;

      this.setState({ value: value, valid: valid });

      if (onChange) {
        onChange(value, valid);
      }
    }
  }, {
    key: 'checkValue',
    value: function checkValue(value) {
      var _props = this.props,
          lowerLimit = _props.lowerLimit,
          upperLimit = _props.upperLimit;

      var result = { correct: value, valid: true };
      if (!(0, _isNil2.default)(lowerLimit)) {
        if (value < lowerLimit) {
          result.correct = lowerLimit;
          result.valid = false;
          return result;
        }
      }
      if (!(0, _isNil2.default)(upperLimit)) {
        if (value > upperLimit) {
          result.correct = upperLimit;
          result.valid = false;
          return result;
        }
      }
      return result;
    }

    // checkedValidMode(value) {
    //   const {validMode} = this.props;
    //   let result;
    //   if (isFunction(validMode)) {
    //     result = this.props.validMode(value);
    //   } else {
    //     result = {isValid: true, value};
    //   }
    //   if (result.isValid) {
    //     result.value = this.checkValue(toNumber(result.value));
    //   }
    //   return result;
    // }

  }, {
    key: 'handleClick',
    value: function handleClick(increment) {
      var onChange = this.props.onChange;

      var _checkValue2 = this.checkValue(this.state.value + increment),
          correct = _checkValue2.correct;

      this.setState({ value: correct, valid: true });

      if (onChange) {
        onChange(correct, true);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          className = _props2.className,
          style = _props2.style,
          placeholder = _props2.placeholder,
          readOnly = _props2.readOnly,
          withInput = _props2.withInput,
          step = _props2.step,
          validMode = _props2.validMode;
      var _state = this.state,
          value = _state.value,
          valid = _state.valid;


      var selectProps = {
        style: style,
        className: (0, _classnames2.default)('number-select', className, {
          readonly: readOnly
        })
      };

      var inputProps = {
        className: (0, _classnames2.default)('number-select-input', {
          error: !valid
        }),
        placeholder: placeholder,
        readOnly: readOnly || !withInput,
        value: (0, _isNil2.default)(value) ? 0 : value
      };
      if (withInput) {
        inputProps.validMode = validMode;
        inputProps.onChange = this.handleChange.bind(this);
      }

      if (readOnly) {
        inputProps.readOnly = readOnly;
      }

      return _react2.default.createElement(
        'div',
        selectProps,
        _jsx('div', {
          className: 'number-select-arrows'
        }, void 0, _jsx('div', {
          className: 'icon-container',
          onClick: readOnly ? null : this.handleClick.bind(this, step)
        }, void 0, _ref), _jsx('div', {
          className: 'icon-container',
          onClick: readOnly ? null : this.handleClick.bind(this, -step)
        }, void 0, _ref2)),
        _react2.default.createElement(_input2.default, inputProps)
      );
    }
  }]);

  return NumberSelect;
}(_react.Component), _class.defaultProps = {
  lowerLimit: null,
  upperLimit: null,
  step: 1,
  value: 0,
  placeholder: '',
  readOnly: false,
  withInput: false,
  validMode: function validMode(value) {
    return {
      isValid: value === '' || DefaultValidModeReg.test(value),
      value: value
    };
  }
}, _temp);
exports.default = NumberSelect;