'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp; /**
                    * Copyright @2016 www.sumscope.com
                    */

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _isString = require('lodash/isString');

var _isString2 = _interopRequireDefault(_isString);

var _isObject = require('lodash/isObject');

var _isObject2 = _interopRequireDefault(_isObject);

var _cloneDeep = require('lodash/cloneDeep');

var _cloneDeep2 = _interopRequireDefault(_cloneDeep);

var _some = require('lodash/some');

var _some2 = _interopRequireDefault(_some);

var _keyBy = require('lodash/keyBy');

var _keyBy2 = _interopRequireDefault(_keyBy);

var _eq = require('lodash/eq');

var _eq2 = _interopRequireDefault(_eq);

var _sscAnalytics = require('ssc-analytics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Options = (_temp = _class = function (_React$Component) {
  _inherits(Options, _React$Component);

  function Options(props) {
    _classCallCheck(this, Options);

    var _this = _possibleConstructorReturn(this, (Options.__proto__ || Object.getPrototypeOf(Options)).call(this, props));

    _this.getValues = function () {
      return (_this.state.values || []).filter(function (v) {
        return v.active;
      }).map(function (v) {
        return v.value;
      });
    };

    _this.state = {
      values: _this.formatValues(props.items)
    };
    return _this;
  }

  _createClass(Options, [{
    key: 'formatValues',
    value: function formatValues(items) {
      var v = (0, _cloneDeep2.default)(items);
      if (!(0, _isEmpty2.default)(v) && !(0, _some2.default)(v, 'active')) {
        (0, _map2.default)(v, function (o) {
          o.active = o.isAll;
        });
      }
      return v;
    }
  }, {
    key: 'handleClick',
    value: function handleClick(value, active) {
      var isRender = true;
      var _props = this.props,
          onChange = _props.onChange,
          multiple = _props.multiple;

      if (multiple) {
        isRender = this.multipleSelect(value, active);
      } else {
        isRender = this.singleSelect(value, active);
      }
      if (active) {
        var itemMap = (0, _keyBy2.default)(this.props.items, 'value');
        (0, _sscAnalytics.tracker)('click', this.context.businessKey + '.' + this.props.label + '.' + this.getTabText(itemMap[value].text), this.context.componentName + '.Option');
      }
      if (isRender && onChange) {
        onChange(value, active);
      }
    }
  }, {
    key: 'getTabText',
    value: function getTabText(tab) {
      var text = 'EMPTY';
      if ((0, _isString2.default)(tab)) {
        text = tab;
      } else if ((0, _isObject2.default)(tab)) {
        text = tab.props.text;
      }
      return text;
    }
  }, {
    key: 'singleSelect',
    value: function singleSelect(value) {
      var isRender = true;
      var values = this.state.values.map(function (v) {
        if ((0, _eq2.default)(v.value, value) && v.active) {
          isRender = false;
        } else {
          v.active = (0, _eq2.default)(v.value, value);
        }
        return v;
      });
      if (isRender) {
        this.setState({ values: values });
      }
      return isRender;
    }
  }, {
    key: 'multipleSelect',
    value: function multipleSelect(value, active) {
      var isClickAll = false;
      var values = this.state.values.map(function (d) {
        if ((0, _eq2.default)(d.value, value)) {
          d.active = active;
          isClickAll = d.isAll;
        }
        if (d.isAll) {
          d.active = false;
        }
        return d;
      });
      isClickAll || !this.isExistedActive(values) ? this.singleSelect('ALL') : this.setState({ values: values });
      return true;
    }
  }, {
    key: 'isExistedActive',
    value: function isExistedActive(values) {
      var isExisted = false;
      values.map(function (v) {
        if (v.active) {
          isExisted = true;
        }
      });
      return isExisted;
    }
  }, {
    key: 'renderOption',
    value: function renderOption() {
      var _this2 = this;

      var values = this.state.values;

      if ((0, _isEmpty2.default)(values)) {
        return '';
      } else {
        return values.map(function (d, i) {
          return _jsx('span', {
            className: (0, _classnames2.default)('option', { active: d.active }),
            onClick: _this2.handleClick.bind(_this2, d.value, !d.active)
          }, d.value + i, d.text);
        });
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var items = nextProps.items;

      if (!(0, _isEqual2.default)(items, this.state.values)) {
        this.state.values = this.formatValues(items);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          className = _props2.className,
          label = _props2.label,
          showLabel = _props2.showLabel;

      var props = {
        className: (0, _classnames2.default)(className)
      };
      return _react2.default.createElement(
        'div',
        props,
        showLabel ? _jsx('label', {}, void 0, label + '：') : '',
        _jsx('div', {
          className: 'options'
        }, void 0, this.renderOption())
      );
    }
  }]);

  return Options;
}(_react2.default.Component), _class.defaultProps = {
  items: [],
  showAll: false,
  multiple: false,
  label: undefined,
  showLabel: true
}, _class.contextTypes = {
  businessKey: _propTypes2.default.string,
  componentName: _propTypes2.default.string
}, _temp);
exports.default = Options;