'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp, _class2, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _dom = require('../../utils/dom');

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PopoverContainer = (_temp = _class = function (_React$Component) {
  _inherits(PopoverContainer, _React$Component);

  function PopoverContainer(props) {
    _classCallCheck(this, PopoverContainer);

    var _this = _possibleConstructorReturn(this, (PopoverContainer.__proto__ || Object.getPrototypeOf(PopoverContainer)).call(this, props));

    _this.state = {
      top: -1
    };
    return _this;
  }

  _createClass(PopoverContainer, [{
    key: 'renderContent',
    value: function renderContent() {
      var _props = this.props,
          popoverWidth = _props.popoverWidth,
          popoverContent = _props.popoverContent,
          popoverNode = _props.popoverNode;

      var content = typeof popoverContent === 'function' ? popoverContent() : popoverNode.innerHTML;

      var contentStyle = {};
      contentStyle.maxWidth = popoverWidth;

      return _jsx('div', {
        className: 'popover-content',
        style: contentStyle
      }, void 0, content);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.state.top = -1;
    }
  }, {
    key: 'changeTop',
    value: function changeTop() {
      if (this.refs.popover.offsetTop < 0) {
        this.setState({ top: 5 });
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.changeTop();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.changeTop();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          popoverWidth = _props2.popoverWidth,
          isShown = _props2.isShown,
          ptX = _props2.ptX,
          ptY = _props2.ptY;

      var winSize = (0, _dom.getWindowSize)();

      var style = {};
      style.display = isShown ? 'block' : 'none';
      if (ptX + popoverWidth > winSize.width) {
        style.right = winSize.width - ptX;
      } else {
        style.left = ptX;
      }
      if (this.state.top !== -1) {
        style.top = 5;
      } else {
        style.bottom = winSize.height - ptY;
      }

      return _react2.default.createElement(
        'div',
        { ref: 'popover', className: 'popover', style: style },
        isShown ? this.renderContent.call(this) : ''
      );
    }
  }]);

  return PopoverContainer;
}(_react2.default.Component), _class.defaultProps = {
  ptX: 0,
  ptY: 0
}, _temp);

var _ref = _jsx('span', {
  className: 'popover-loading'
}, void 0, 'Loading');

var Popover = (_temp2 = _class2 = function (_React$Component2) {
  _inherits(Popover, _React$Component2);

  function Popover(props) {
    _classCallCheck(this, Popover);

    var _this2 = _possibleConstructorReturn(this, (Popover.__proto__ || Object.getPrototypeOf(Popover)).call(this, props));

    _this2.state = {
      isShow: false,
      target: ''
    };
    return _this2;
  }

  _createClass(Popover, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var evtTarget = this.props.evtTarget;

      var evtNode = this.refs.container.querySelector('.' + evtTarget);
      if (evtNode) {
        evtNode.addEventListener('mouseenter', this.handleMouseEnter.bind(this));
        evtNode.addEventListener('mouseleave', this.handleMouseLeave.bind(this));
      }
    }
  }, {
    key: 'setPopoverContent',
    value: function setPopoverContent() {
      this.showPopover();
    }
  }, {
    key: 'handleMouseEnter',
    value: function handleMouseEnter(e) {
      e = e || window.event;
      this.state.target = e.target;
      if (!(0, _dom.isExistedListContainer)()) {
        (0, _dom.createListContainer)();
      }

      var alwaysShown = this.props.alwaysShown;

      var maxWidth = parseInt(e.target.style.maxWidth, 10);
      var offsetWidth = Math.ceil((0, _dom.getPosElement)(e.target).width);
      if (maxWidth <= offsetWidth || alwaysShown) {
        if (this.state.isShow) {
          return;
        }
        var isAjax = (0, _isFunction2.default)(this.props.ajaxData);
        this.state.isShow = true;
        if (isAjax) {
          this.props.ajaxData();
        }
        this.showPopover(isAjax);
      }
    }
  }, {
    key: 'showPopover',
    value: function showPopover() {
      var isAjax = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var target = this.state.target;
      var _props3 = this.props,
          popoverWidth = _props3.popoverWidth,
          popoverContent = _props3.popoverContent,
          positionType = _props3.positionType;

      var targetRect = target.getBoundingClientRect();

      var _getPosition = this.getPosition(targetRect, positionType),
          ptX = _getPosition.ptX,
          ptY = _getPosition.ptY;

      var props = {
        popoverWidth: popoverWidth,
        popoverContent: isAjax ? function () {
          return _ref;
        } : popoverContent,
        popoverNode: target,
        isShown: this.state.isShow,
        ptX: ptX,
        ptY: ptY
      };

      _reactDom2.default.render(_react2.default.createElement(PopoverContainer, props), _dom.listContainer);
    }
  }, {
    key: 'getPosition',
    value: function getPosition(targetRect, positionType) {
      var ptX = '';
      var ptY = '';
      if ((0, _isEqual2.default)(positionType, 'default')) {
        ptX = targetRect.left + targetRect.width / 2 + 10;
        ptY = targetRect.top - 5;
      } else if ((0, _isEqual2.default)(positionType, 'rightDown')) {
        ptX = targetRect.left + targetRect.width;
        ptY = targetRect.top + 66;
      } else {
        ptX = targetRect.left + targetRect.width / 2 + 10;
        ptY = targetRect.top - 5;
      }
      return {
        ptX: ptX,
        ptY: ptY
      };
    }
  }, {
    key: 'handleMouseLeave',
    value: function handleMouseLeave(e) {
      e = e || window.event;
      var popoverWidth = this.props.popoverWidth;

      this.state.isShow = false;
      _reactDom2.default.render(_jsx(PopoverContainer, {
        isShown: false,
        popoverWidth: popoverWidth,
        popoverNode: e.target
      }), _dom.listContainer);
    }
  }, {
    key: 'render',
    value: function render() {
      var style = this.props.style;

      return _react2.default.createElement(
        'div',
        { className: 'td-container', ref: 'container', style: style },
        this.props.children
      );
    }
  }]);

  return Popover;
}(_react2.default.Component), _class2.defaultProps = {
  popoverWidth: 200,
  popoverContent: null,
  alwaysShown: false,
  positionType: 'default'
}, _temp2);
exports.default = Popover;