'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _dom = require('../../utils/dom');

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _forEach = require('lodash/forEach');

var _forEach2 = _interopRequireDefault(_forEach);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _ref = _jsx('div', {
  className: 'hidden'
});

var PopupMenu = function (_Component) {
  _inherits(PopupMenu, _Component);

  function PopupMenu(props) {
    _classCallCheck(this, PopupMenu);

    var _this = _possibleConstructorReturn(this, (PopupMenu.__proto__ || Object.getPrototypeOf(PopupMenu)).call(this, props));

    _this.state = {
      isShown: true,
      ptPos: props.ptPos
    };
    _this.size = _this.calcSize(props.command);
    return _this;
  }

  _createClass(PopupMenu, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var isShown = nextProps.isShown,
          ptPos = nextProps.ptPos;

      if (isShown !== this.state.isShown || ptPos !== this.state.ptPos) {
        this.setState({ isShown: isShown, ptPos: ptPos });
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var isShown = nextState.isShown,
          ptPos = nextState.ptPos;

      if (isShown !== this.state.isShown) {
        return true;
      }
      if (ptPos !== this.state.ptPos) {
        return true;
      }
      return false;
    }
  }, {
    key: 'calcSize',
    value: function calcSize(command) {
      return {
        height: (0, _isNil2.default)(command) ? 0 : command.length * 30,
        width: 120
      };
    }
  }, {
    key: 'onValidArea',
    value: function onValidArea(ptPos) {
      var parentNode = this.props.parentNode;

      var _getPosElement = (0, _dom.getPosElement)(parentNode),
          top = _getPosElement.top,
          bottom = _getPosElement.bottom,
          left = _getPosElement.left,
          right = _getPosElement.right;

      if (ptPos.left >= left && ptPos.left <= right && ptPos.top >= top && ptPos.top <= bottom) {
        return true;
      }
      return false;
    }
  }, {
    key: 'close',
    value: function close() {
      this.setState({ isShown: false });
    }
  }, {
    key: 'onCommand',
    value: function onCommand(nCmd) {
      this.props.onCommand(nCmd);
      this.close();
    }
  }, {
    key: 'onContextMenu',
    value: function onContextMenu(e) {
      e.preventDefault();
      var ptPos = {
        top: e.pageY,
        left: e.pageX
      };
      if (this.onValidArea(ptPos)) {
        this.setState({ ptPos: ptPos });
      } else {
        this.close();
      }
    }
  }, {
    key: 'renderContent',
    value: function renderContent() {
      var _this2 = this;

      var liz = [];
      (0, _forEach2.default)(this.props.command, function (command) {
        liz.push(_jsx('li', {
          onClick: _this2.onCommand.bind(_this2, command.id)
        }, command.id, command.text));
      });
      return _jsx('ul', {
        className: 'command-content'
      }, void 0, liz);
    }
  }, {
    key: 'setStyle',
    value: function setStyle() {
      var ptPos = this.state.ptPos;

      var _getWindowSize = (0, _dom.getWindowSize)(),
          height = _getWindowSize.height,
          width = _getWindowSize.width;

      var style = {
        position: 'absolute'
      };
      if (ptPos.top + this.size.height > height) {
        style.bottom = height - ptPos.top;
      } else {
        style.top = ptPos.top;
      }
      if (ptPos.left + this.size.width > width) {
        style.right = width - ptPos.left;
      } else {
        style.left = ptPos.left;
      }
      return style;
    }
  }, {
    key: 'render',
    value: function render() {
      var isShown = this.state.isShown;

      if (!isShown) {
        return _ref;
      }
      return _jsx('div', {
        className: 'popup-menu',
        onClick: this.close.bind(this),
        onContextMenu: this.onContextMenu.bind(this)
      }, void 0, _jsx('div', {
        className: 'menu-content',
        style: this.setStyle()
      }, void 0, this.renderContent()));
    }
  }]);

  return PopupMenu;
}(_react.Component);

exports.default = PopupMenu;