'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _range = require('lodash/range');

var _range2 = _interopRequireDefault(_range);

var _layout = require('../layout');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component;

var _ref = _jsx('div', {});

var ProgressColorLamp = (_temp = _class = function (_Component) {
  _inherits(ProgressColorLamp, _Component);

  function ProgressColorLamp() {
    _classCallCheck(this, ProgressColorLamp);

    return _possibleConstructorReturn(this, (ProgressColorLamp.__proto__ || Object.getPrototypeOf(ProgressColorLamp)).apply(this, arguments));
  }

  _createClass(ProgressColorLamp, [{
    key: 'getLampClass',
    value: function getLampClass(n) {
      var _props = this.props,
          progress = _props.progress,
          colorClass = _props.colorClass,
          darkClass = _props.darkClass;

      if (n === progress) {
        if ((0, _isArray2.default)(colorClass)) {
          var len = colorClass.length;
          if (progress < len) return colorClass[progress];
          return darkClass;
        }
        return colorClass;
      }
      return darkClass;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          className = _props2.className,
          total = _props2.total,
          diameter = _props2.diameter;

      if (diameter <= 0 || total <= 0) {
        return _ref;
      }

      var itemStyle = {
        height: diameter + 'px',
        width: diameter + 'px'
      };
      var totalWidth = (diameter + 3) * total - 3;
      var totalStyle = {
        height: diameter + 'px',
        width: totalWidth + 'px'
      };

      var lamps = (0, _map2.default)((0, _range2.default)(total), function (n) {
        var classes = (0, _classnames2.default)('lamp-item', _this2.getLampClass(n));
        return _jsx('div', {
          className: classes,
          style: itemStyle
        }, n);
      });
      return _jsx(_layout.LayoutH, {
        className: (0, _classnames2.default)('progress-color-lamp', className),
        style: totalStyle
      }, void 0, lamps);
    }
  }]);

  return ProgressColorLamp;
}(Component), _class.defaultProps = {
  progress: 0,
  total: 1,
  diameter: 7,
  color: 'lamp-done',
  darkClass: 'lamp-dark'
}, _temp);
exports.default = ProgressColorLamp;