'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _round = require('lodash/round');

var _round2 = _interopRequireDefault(_round);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ProgressBar = (_temp = _class = function (_React$Component) {
  _inherits(ProgressBar, _React$Component);

  function ProgressBar(props) {
    _classCallCheck(this, ProgressBar);

    var _this = _possibleConstructorReturn(this, (ProgressBar.__proto__ || Object.getPrototypeOf(ProgressBar)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(ProgressBar, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.value,
          title1 = _props.title1,
          title2 = _props.title2,
          type = _props.type,
          showTick = _props.showTick,
          style = _props.style,
          progressHeight = _props.progressHeight,
          textWidth = _props.textWidth,
          decimalPlaces = _props.decimalPlaces;

      var percent = (0, _round2.default)(value, 2);
      if (value < 0) {
        percent = 0;
      } else if (value > 100) {
        percent = 100;
      }
      percent = percent.toFixed(decimalPlaces);
      var nextPercent = (100.00 - percent).toFixed(decimalPlaces);
      return _jsx('div', {
        className: 'progress-bar',
        style: style
      }, void 0, _jsx('div', {
        className: 'progress-body'
      }, void 0, _jsx('div', {
        className: 'title',
        style: { width: textWidth }
      }, void 0, title1), _jsx('div', {
        className: (0, _classnames2.default)('progress-total', type),
        style: { height: progressHeight }
      }, void 0, _jsx('div', {
        className: (0, _classnames2.default)('progress', { 'hundred': percent === 100 }),
        style: { width: percent + '%' }
      })), _jsx('div', {
        className: 'title'
      }, void 0, title2)), showTick ? _jsx('div', {
        className: 'progress-tick'
      }, void 0, _jsx('div', {
        style: { width: percent + '%' }
      }, void 0, percent + '%'), _jsx('div', {
        style: { width: nextPercent + '%' }
      }, void 0, nextPercent + '%')) : '');
    }
  }]);

  return ProgressBar;
}(_react2.default.Component), _class.defaultProps = {
  decimalPlaces: 2,
  type: 'single',
  value: 50,
  showTick: false,
  progressHeight: 16,
  progressWidth: '100%'
}, _temp);
exports.default = ProgressBar;