'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _class, _temp;

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _input = require('../input');

var _input2 = _interopRequireDefault(_input);

var _button = require('../button');

var _button2 = _interopRequireDefault(_button);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _dom = require('../../utils/dom');

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _cloneDeep = require('lodash/cloneDeep');

var _cloneDeep2 = _interopRequireDefault(_cloneDeep);

var _sscAnalytics = require('ssc-analytics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _ref = _jsx('div', {
  className: 'hidden'
});

var SelectContainer = function (_Component) {
  _inherits(SelectContainer, _Component);

  function SelectContainer() {
    _classCallCheck(this, SelectContainer);

    return _possibleConstructorReturn(this, (SelectContainer.__proto__ || Object.getPrototypeOf(SelectContainer)).apply(this, arguments));
  }

  _createClass(SelectContainer, [{
    key: 'close',
    value: function close() {
      var close = this.props.close;

      if (close) {
        close();
      }
    }
  }, {
    key: 'onSelected',
    value: function onSelected(i, e) {
      var getSelected = this.props.getSelected;

      if (getSelected) {
        getSelected(i);
      }
      this.close();
      e.preventDefault();
    }
  }, {
    key: 'renderInner',
    value: function renderInner() {
      var _this2 = this;

      var _props = this.props,
          data = _props.data,
          overflow = _props.overflow,
          parentRect = _props.parentRect;

      var options = data.map(function (d, i) {
        return _jsx('li', {
          onMouseDown: _this2.onSelected.bind(_this2, i)
        }, i, d.text);
      });
      var style = {};
      style.width = parentRect.width;
      style.left = parentRect.left;
      if (overflow.y) {
        style.bottom = (0, _dom.getWindowSize)().height - parentRect.top;
      } else {
        style.top = parentRect.top + parentRect.height;
      }

      return _jsx('div', {
        className: 'select-options-wrap',
        style: style
      }, void 0, _jsx('div', {
        className: 'select-options'
      }, void 0, _jsx('ul', {}, void 0, options)));
    }
  }, {
    key: 'render',
    value: function render() {
      var open = this.props.open;

      if (open) {
        return this.renderInner();
      } else {
        return _ref;
      }
    }
  }]);

  return SelectContainer;
}(_react.Component);

var _ref2 = _jsx(SelectContainer, {
  open: false
});

var _ref3 = _jsx('span', {
  className: 'select-arrow'
}, void 0, _jsx('span', {
  className: 'icon-container'
}, void 0, _jsx('i', {
  className: 'icon-font icon-down'
})));

var Select = (_temp = _class = function (_Component2) {
  _inherits(Select, _Component2);

  function Select(props) {
    _classCallCheck(this, Select);

    var _this3 = _possibleConstructorReturn(this, (Select.__proto__ || Object.getPrototypeOf(Select)).call(this, props));

    var value = props.value;
    var data = _this3.getData(props.data, value, true);
    _this3.state = {
      value: value,
      data: data,
      open: props.open
    };
    return _this3;
  }

  _createClass(Select, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var value = nextProps.value,
          data = nextProps.data;

      if (!(0, _isEqual2.default)(value, this.state.value)) {
        var dataNew = this.getData(data, value);
        this.state.value = value;
        this.state.data = dataNew;
      }

      if ((0, _isArray2.default)(data) && !(0, _isEqual2.default)(data, this.state.data)) {
        this.state.data = this.getData(data, value);
      }
    }
  }, {
    key: 'getData',
    value: function getData(data, value) {
      var isFirst = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      var dataList = void 0;
      if (typeof data === 'function') {
        dataList = isFirst ? data() : data(value);
      } else {
        dataList = (0, _cloneDeep2.default)(data);
      }
      return this.formatData(dataList, value);
    }
  }, {
    key: 'formatData',
    value: function formatData(data, value) {
      return data.map(function (d) {
        d.selected = d.id === value;
        return d;
      });
    }
  }, {
    key: 'setValue',
    value: function setValue(data) {
      var value = '';
      data.forEach(function (d) {
        if (d.selected) {
          value = d.id;
        }
      });
      return value;
    }
  }, {
    key: 'getValue',
    value: function getValue() {
      return this.state.value;
    }
  }, {
    key: 'showHideOptions',
    value: function showHideOptions() {
      var _props2 = this.props,
          readOnly = _props2.readOnly,
          withInput = _props2.withInput;

      if (readOnly) {
        return;
      }

      var inputNode = _reactDom2.default.findDOMNode(this.refs.input);
      inputNode.focus();
      if (withInput) {
        inputNode.select();
      }

      var open = !this.state.open;
      if (open) {
        this.showOptions.call(this);
      } else {
        this.hideOptions.call(this);
      }
    }
  }, {
    key: 'showOptions',
    value: function showOptions() {
      var data = this.state.data;

      var num = data.length;
      var optHeight = num * 28 > 150 ? 150 : num * 28;
      var elm = this.refs.container;
      var parentRect = (0, _dom.getPosElement)(elm);
      var props = {
        data: data,
        open: true,
        overflow: (0, _dom.isOverFlow)(elm, parentRect.width, optHeight),
        parentRect: (0, _dom.getPosElement)(elm),
        getSelected: this.handleSelect.bind(this),
        close: this.hideOptions.bind(this)
      };

      if (!(0, _dom.isExistedListContainer)()) {
        (0, _dom.createListContainer)();
      }

      _reactDom2.default.render(_react2.default.createElement(SelectContainer, props), _dom.listContainer);
      this.setState({ open: true });
    }
  }, {
    key: 'hideOptions',
    value: function hideOptions() {
      var open = this.state.open;

      if (open) {
        _reactDom2.default.render(_ref2, _dom.listContainer);
        this.setState({ open: false });
      }
    }
  }, {
    key: 'handleSelect',
    value: function handleSelect(i) {
      var _this4 = this;

      var onChange = this.props.onChange;

      var data = this.state.data;

      data.map(function (d, index) {
        d.selected = index === i;
        if (d.selected) {
          (0, _sscAnalytics.tracker)('click', _this4.context.businessKey + '.' + d.text, _this4.context.componentName);
        }
      });
      var value = this.setValue.call(this, data);
      this.state.value = value;

      if (onChange) {
        onChange(value);
      }
    }
  }, {
    key: 'handleChange',
    value: function handleChange(v) {
      var _props3 = this.props,
          data = _props3.data,
          onChange = _props3.onChange;


      this.state.value = v;
      if (typeof data === 'function') {
        this.state.data = data(v);
      }
      this.formatData(this.state.data, v);

      if (typeof data === 'function') {
        this.showOptions();
      } else {
        this.hideOptions();
      }

      if (onChange) {
        onChange(v);
      }
    }
  }, {
    key: 'onClear',
    value: function onClear(value, e) {
      e.preventDefault();
      this.setState({ value: value });

      var onChange = this.props.onChange;

      if (onChange) {
        onChange(value);
      }
    }
  }, {
    key: 'renderClear',
    value: function renderClear() {
      var value = this.state.value;

      if ((0, _isEmpty2.default)(value) || (0, _isNil2.default)(value)) {
        return '';
      }
      return _jsx('span', {
        className: 'select-clear'
      }, void 0, _jsx(_button2.default, {
        onMouseDown: this.onClear.bind(this, '')
      }, void 0, '\u6E05\u7A7A'));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props4 = this.props,
          className = _props4.className,
          readOnly = _props4.readOnly,
          placeholder = _props4.placeholder,
          style = _props4.style,
          withInput = _props4.withInput,
          validMode = _props4.validMode,
          clear = _props4.clear;
      var _state = this.state,
          data = _state.data,
          open = _state.open,
          value = _state.value;

      var displayV = value;
      data.map(function (d) {
        if (d.selected) displayV = d.text;
      });

      var selectProps = {
        ref: 'container',
        style: style,
        className: (0, _classnames2.default)('select', className, {
          open: open,
          readonly: readOnly,
          withInput: withInput
        }),
        onBlur: this.hideOptions.bind(this),
        onClick: this.showHideOptions.bind(this)
      };

      var inputProps = {
        ref: 'input',
        className: 'select-input',
        placeholder: placeholder,
        readOnly: !withInput,
        value: (0, _isNil2.default)(displayV) ? '' : displayV
      };

      if (withInput) {
        inputProps.validMode = validMode;
        inputProps.onChange = this.handleChange.bind(this);
      }

      if (readOnly) {
        inputProps.readOnly = readOnly;
      }

      return _react2.default.createElement(
        'div',
        selectProps,
        _ref3,
        _react2.default.createElement(_input2.default, inputProps),
        clear ? this.renderClear() : ''
      );
    }
  }]);

  return Select;
}(_react.Component), _class.defaultProps = {
  data: [], // {id:text:[selected:]}
  value: '',
  readOnly: false,
  placeholder: '',
  withInput: false,
  open: false,
  clear: false
}, _class.contextTypes = {
  businessKey: _propTypes2.default.string,
  componentName: _propTypes2.default.string
}, _temp);
exports.default = Select;