'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _forEach = require('lodash/forEach');

var _forEach2 = _interopRequireDefault(_forEach);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _SliderItem = require('./SliderItem');

var _SliderItem2 = _interopRequireDefault(_SliderItem);

var _SliderDots = require('./SliderDots');

var _SliderDots2 = _interopRequireDefault(_SliderDots);

var _SliderArrows = require('./SliderArrows');

var _SliderArrows2 = _interopRequireDefault(_SliderArrows);

var _reactDom = require('react-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component,
    Children = _react2.default.Children;
var Slider = (_temp = _class = function (_Component) {
  _inherits(Slider, _Component);

  function Slider(props) {
    _classCallCheck(this, Slider);

    var _this = _possibleConstructorReturn(this, (Slider.__proto__ || Object.getPrototypeOf(Slider)).call(this, props));

    _this.getStyle = function (idx) {
      var currentIndex = _this.currentIndex,
          previousIndex = _this.previousIndex;

      var count = _this.pages.length;
      var transformIndex = idx - currentIndex;
      var zIndex = idx === currentIndex ? 3 : 1;
      if (currentIndex === 0 && idx === count - 1) {
        transformIndex = -1;
      }
      if (currentIndex === count - 1 && idx === 0) {
        transformIndex = 1;
      }
      if (idx === previousIndex) {
        zIndex = 2;
      }
      return {
        transform: 'translate3d(' + 100 * transformIndex + '%, 0, 0)',
        transition: 'transform ' + _this.props.speed + 's ease-out',
        zIndex: zIndex
      };
    };

    _this.updatePage = function () {
      (0, _forEach2.default)(_this.pages, function (page, idx) {
        var style = _this.getStyle(idx);
        var node = (0, _reactDom.findDOMNode)(_this.refs[page]);
        node.style.transform = style.transform;
        node.style.transition = style.transition;
        node.style.zIndex = style.zIndex;
      });
    };

    _this.currentIndex = 0;
    _this.previousIndex = undefined;
    _this.pages = [];
    _this.autoPlayFlag = null;
    _this.count = 0;
    if (!(0, _isNil2.default)(props.children)) {
      _this.count = props.children.length;
    }
    return _this;
  }

  _createClass(Slider, [{
    key: 'turn',
    value: function turn(n) {
      var _n = this.currentIndex + n;
      if (_n < 0) {
        _n = _n + this.count;
      }
      if (_n >= this.count) {
        _n = _n - this.count;
      }
      this.previousIndex = this.currentIndex;
      this.currentIndex = _n;
      if (!(0, _isNil2.default)(this.refs.sliderDots)) {
        this.refs.sliderDots.update(_n);
      }
      this.updatePage();
    }
  }, {
    key: 'goPlay',
    value: function goPlay() {
      var _this2 = this;

      var _props = this.props,
          autoplay = _props.autoplay,
          delay = _props.delay;

      if (autoplay) {
        this.autoPlayFlag = setInterval(function () {
          _this2.turn.call(_this2, 1);
        }, delay * 1000);
      }
    }
  }, {
    key: 'handleClick',
    value: function handleClick(item) {
      var onClick = this.props.onClick;

      if ((0, _isFunction2.default)(onClick)) {
        onClick(item);
      }
    }
  }, {
    key: 'pausePlay',
    value: function pausePlay() {
      clearInterval(this.autoPlayFlag);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.goPlay();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.pausePlay.call(this);
    }
  }, {
    key: 'renderItems',
    value: function renderItems() {
      var _this3 = this;

      var children = this.props.children;

      return Children.map(children, function (child, idx) {
        var key = 'sliderPage' + idx;
        var props = {
          count: _this3.count,
          ref: key,
          key: key,
          style: _this3.getStyle(idx),
          onClick: _this3.handleClick.bind(_this3)
        };
        _this3.pages.push(key);
        return _react2.default.createElement(
          _SliderItem2.default,
          props,
          child
        );
      });
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var should = false;

      return should;
    }
  }, {
    key: 'renderDots',
    value: function renderDots() {
      return _react2.default.createElement(_SliderDots2.default, {
        ref: 'sliderDots',
        turn: this.turn.bind(this),
        count: this.count,
        currentIndex: this.currentIndex
      });
    }
  }, {
    key: 'renderArrows',
    value: function renderArrows() {
      return _jsx(_SliderArrows2.default, {
        turn: this.turn.bind(this)
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          pause = _props2.pause,
          arrows = _props2.arrows,
          dots = _props2.dots,
          className = _props2.className,
          children = _props2.children;

      var props = {
        className: (0, _classnames2.default)(['slider', className]),
        onMouseOver: pause ? this.pausePlay.bind(this) : null,
        onMouseOut: pause ? this.goPlay.bind(this) : null
      };

      return _react2.default.createElement(
        'div',
        props,
        _jsx('div', {
          className: 'slider-items-wrapped'
        }, void 0, this.renderItems.call(this)),
        arrows && children.length > 1 ? this.renderArrows.call(this) : null,
        dots && children.length > 1 ? this.renderDots.call(this) : null
      );
    }
  }]);

  return Slider;
}(Component), _class.defaultProps = {
  speed: 0.5,
  delay: 2,
  pause: true,
  autoplay: true,
  dots: false,
  arrows: false,
  items: []
}, _temp);
exports.default = Slider;