'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _checkbox = require('../checkbox');

var _checkbox2 = _interopRequireDefault(_checkbox);

var _message = require('../message');

var _message2 = _interopRequireDefault(_message);

var _modal = require('../modal');

var _modal2 = _interopRequireDefault(_modal);

var _forEach = require('lodash/forEach');

var _forEach2 = _interopRequireDefault(_forEach);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _ref = _jsx('div', {}, void 0, '\u8BBE\u7F6E\u9700\u8981\u663E\u793A\u7684\u5217:');

var SettingsModal = function (_Component) {
  _inherits(SettingsModal, _Component);

  function SettingsModal(props) {
    _classCallCheck(this, SettingsModal);

    var _this = _possibleConstructorReturn(this, (SettingsModal.__proto__ || Object.getPrototypeOf(SettingsModal)).call(this, props));

    _this.state = {
      headers: [],
      isShown: false,
      headerStatus: {}
    };
    return _this;
  }

  _createClass(SettingsModal, [{
    key: 'showModal',
    value: function showModal(headers) {
      var _this2 = this;

      this.state.headers = headers;
      this.state.headerStatus = {};
      (0, _forEach2.default)(headers, function (head) {
        _this2.state.headerStatus[head.name] = head.showStatus;
      });
      this.setState({ isShown: true });
    }
  }, {
    key: 'onClose',
    value: function onClose() {
      this.setState({ isShown: false });
    }
  }, {
    key: 'onChange',
    value: function onChange(name, e) {
      this.state.headerStatus[name] = e.target.checked;
    }
  }, {
    key: 'onConfirm',
    value: function onConfirm() {
      var hasShow = false;
      var _state = this.state,
          headers = _state.headers,
          headerStatus = _state.headerStatus;

      (0, _forEach2.default)(headers, function (head) {
        head.showStatus = headerStatus[head.name];
        if (head.showStatus !== false) {
          hasShow = true;
        }
      });
      if (!hasShow) {
        _message2.default.info('至少要显示一列！');
        return;
      }
      this.props.onConfirm();
      this.setState({ isShown: false });
    }
  }, {
    key: 'renderContent',
    value: function renderContent() {
      var _this3 = this;

      var checks = [];
      var _state2 = this.state,
          headers = _state2.headers,
          headerStatus = _state2.headerStatus;

      (0, _forEach2.default)(headers, function (head) {
        var showStatus = headerStatus[head.name];
        if (showStatus === true || showStatus === false) {
          checks.push(_jsx(_checkbox2.default, {
            text: head.header,
            onChange: _this3.onChange.bind(_this3, head.name),
            checked: showStatus
          }, head.name));
        }
      });
      return _jsx('div', {
        className: 'table-settings'
      }, void 0, _ref, checks);
    }
  }, {
    key: 'render',
    value: function render() {
      var isShown = this.state.isShown;

      var props = {
        isDragged: true,
        isShown: isShown,
        header: '表格设置',
        buttons: {
          CONFIRM: this.onConfirm.bind(this),
          CANCEL: true
        },
        onClose: this.onClose.bind(this)
      };
      return _react2.default.createElement(
        _modal2.default,
        props,
        this.renderContent()
      );
    }
  }]);

  return SettingsModal;
}(_react.Component);

exports.default = SettingsModal;