'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _TableHeader = require('./TableHeader');

var _TableHeader2 = _interopRequireDefault(_TableHeader);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _filter = require('lodash/filter');

var _filter2 = _interopRequireDefault(_filter);

var _clone = require('lodash/clone');

var _clone2 = _interopRequireDefault(_clone);

var _forEach = require('lodash/forEach');

var _forEach2 = _interopRequireDefault(_forEach);

var _floor = require('lodash/floor');

var _floor2 = _interopRequireDefault(_floor);

var _ceil = require('lodash/ceil');

var _ceil2 = _interopRequireDefault(_ceil);

var _sortBy = require('lodash/sortBy');

var _sortBy2 = _interopRequireDefault(_sortBy);

var _checkbox = require('../checkbox');

var _checkbox2 = _interopRequireDefault(_checkbox);

var _FlushTypes = require('../../constants/FlushTypes');

var _FlushTypes2 = _interopRequireDefault(_FlushTypes);

var _blueimpMd = require('blueimp-md5');

var _blueimpMd2 = _interopRequireDefault(_blueimpMd);

var _sscAnalytics = require('ssc-analytics');

var _storageUtils = require('../../utils/storageUtils');

var _SettingsModal = require('./SettingsModal');

var _SettingsModal2 = _interopRequireDefault(_SettingsModal);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _dom = require('../../utils/dom');

var _popupmenu = require('../popupmenu');

var _popupmenu2 = _interopRequireDefault(_popupmenu);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Table = (_temp = _class = function (_Component) {
  _inherits(Table, _Component);

  function Table(props) {
    _classCallCheck(this, Table);

    var _this = _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).call(this, props));

    _this.state = {
      index: props.pagination ? props.pagination.props.index : 1,
      data: _this.sortData(null, null, props.data),
      sort: {},
      total: null,
      headers: props.headers,
      colInfo: {},
      bodyHeight: 0,
      scrollPos: 0,
      scrollHeight: 0,
      showData: {
        from: 0,
        to: 40,
        offset: 0
      },
      bodySize: {
        w: 0,
        h: 0
      },
      checkState: props.checkState || {},
      allCheckState: 'unselected',
      headerStatus: {},
      defaultHeaderStatus: {},
      rowHeight: props.rowHeight,
      showSettings: false
    };
    _this.EVT_EMITTER = null;
    return _this;
  }

  _createClass(Table, [{
    key: 'onSelect',
    value: function onSelect(i, e) {
      if (typeof e !== 'boolean') {
        var tagName = e.target.tagName.toLowerCase();
        var classes = e.target.className;
        if (tagName === 'button' || tagName === 'a' || tagName === 'img' || classes.indexOf('btn') !== -1 || classes.indexOf('option') !== -1) {
          if (this.props.onSelected) {
            this.props.onSelected(this.getSelected().length > 0);
          }
          return;
        }
      }

      var _props = this.props,
          keyName = _props.keyName,
          analyticKey = _props.analyticKey,
          isMultiSelect = _props.isMultiSelect;

      if (!isMultiSelect) {
        this.state.checkState = {};
      }
      var _state = this.state,
          data = _state.data,
          checkState = _state.checkState;

      var start = 0;
      var end = 0;
      var checked = false;

      if (i === 'all' || i === undefined) {
        checked = typeof e === 'boolean' ? e : e.target.checked;
        start = 0;
        end = data.length - 1;
      } else {
        if (!data[i].canSelect) {
          return;
        }
        checked = !checkState[data[i][keyName]];
        start = i;
        end = start;
      }
      for (; start <= end; start++) {
        if (data[start].canSelect) {
          checkState[data[start][keyName]] = checked;
        }
      }

      var value = void 0;
      if (i === 'all') {
        value = data;
      } else {
        value = data.slice(start - 1, start);
      }

      (0, _sscAnalytics.tracker)('click', this.context.businessKey + '.选中.' + (i === 'all' ? '全部' : data[i][analyticKey || keyName]), this.context.componentName);
      value = (0, _filter2.default)(value, function (row) {
        return row.canSelect;
      });

      if (this.props.onSelected) {
        this.props.onSelected(checked, value);
      }
      this.setState({ data: data });
      this.markAllCheckState();
    }
  }, {
    key: 'selectAll',
    value: function selectAll(selected) {
      var _this2 = this;

      var keyName = this.props.keyName;

      if (selected) {
        var checkState = (0, _clone2.default)(this.state.checkState);
        (0, _forEach2.default)(this.state.data, function (row) {
          if (row.canSelect && row.existCheck) {
            checkState[row[keyName]] = true;
          }
          _this2.setState({ checkState: checkState });
        });
      } else {
        this.setState({ checkState: {} });
      }
    }
  }, {
    key: 'getHeaderStatus',
    value: function getHeaderStatus(headers) {
      var _this3 = this;

      var name = this.props.name;

      var headerStatus = {};
      if ((0, _storageUtils.canUseLocalStorage)() && name !== 'table') {
        headerStatus = JSON.parse((0, _storageUtils.getItem)('header_status_' + name));
      }
      this.state.defaultHeaderStatus = {};
      (0, _forEach2.default)(headers, function (head) {
        _this3.state.defaultHeaderStatus[head.name] = head.showStatus;
      });
      if (!headerStatus) {
        return;
      }

      (0, _forEach2.default)(headers, function (head) {
        var showStatus = headerStatus[head.name];
        if (showStatus === true || showStatus === false) {
          head.showStatus = showStatus;
        }
      });
      this.state.headerStatus = headerStatus;
    }
  }, {
    key: 'getCurHeaderStatus',
    value: function getCurHeaderStatus() {
      var _state2 = this.state,
          headerStatus = _state2.headerStatus,
          defaultHeaderStatus = _state2.defaultHeaderStatus;

      if (JSON.stringify(headerStatus) === '{}') {
        return defaultHeaderStatus;
      }
      return headerStatus;
    }
  }, {
    key: 'getSelected',
    value: function getSelected(name) {
      var checkState = this.state.checkState;
      var keyName = this.props.keyName;

      var values = [];
      this.state.data.forEach(function (d) {
        if (checkState[d[keyName]]) {
          values.push(name ? d[name] : d);
        }
      });
      return values;
    }
  }, {
    key: 'getHeaders',
    value: function getHeaders() {
      return this.state.headers;
    }
  }, {
    key: 'sortData',
    value: function sortData(key, asc, data) {
      if ((0, _isFunction2.default)(this.props.refresh)) {
        return data;
      }
      if ((0, _isFunction2.default)(this.props.onCustomSort)) {
        var rtn = this.props.onCustomSort(key, asc, data);
        if (rtn) {
          return data;
        }
      }
      if (!key) {
        return data;
      }
      for (var i = 0; i < data.length; i++) {
        for (var j = 0; j < data.length - i - 1; j++) {
          if (asc && data[j][key] > data[j + 1][key] || !asc && data[j][key] < data[j + 1][key]) {
            var temp = data[j];
            data[j] = data[j + 1];
            data[j + 1] = temp;
          }
        }
      }
      return data;
    }
  }, {
    key: 'updateHeaderStatus',
    value: function updateHeaderStatus() {
      var name = this.props.name;

      var headerStatus = {};
      (0, _forEach2.default)(this.state.headers, function (head) {
        headerStatus[head.name] = head.showStatus;
      });
      this.setState({ headerStatus: headerStatus });
      if (name === 'table') {
        console.error('need table name!');
        return;
      }
      (0, _storageUtils.setItem)('header_status_' + name, JSON.stringify(headerStatus));
    }
  }, {
    key: 'onSort',
    value: function onSort(key, asc) {
      this.state.sort = { key: key, asc: asc };
      if ((0, _isFunction2.default)(this.props.onChangeSort)) {
        this.props.onChangeSort(key, asc, this.state.data);
      }
      var data = this.sortData(key, asc, this.state.data);
      this.setState({ data: data });
    }
  }, {
    key: 'onBodyScroll',
    value: function onBodyScroll() {
      var tableBody = this.refs.tableBody;
      var hd = this.refs.header;
      var bs = this.refs.bodyScroll;
      var marginLeft = 0 - tableBody.scrollLeft;
      hd.style.marginLeft = marginLeft + 'px';
      bs.style.right = marginLeft + 'px';
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.markCheckState();
      this.getHeaderStatus(this.state.headers);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setHeaderWidth();
      this.calcRowHeight();
      this.EVT_EMITTER = this.setHeaderWidth.bind(this);
      window.addEventListener('resize', this.EVT_EMITTER);

      var body = this.refs.tableBody;
      this.state.bodyHeight = body.clientHeight;
      this.state.showData.to = body.clientHeight / this.state.rowHeight;
      this.state.bodySize = { w: body.offsetWidth, h: body.offsetHeight };
      if (this.props.resizable) {
        setInterval(this.onResizeTable.bind(this), 200);
      }
      this.flashRow();
    }
  }, {
    key: 'calcRowHeight',
    value: function calcRowHeight() {
      var body = this.refs.body;
      if (!body || body.offsetWidth === 0) {
        return;
      }
      var tr = body.querySelector('tr');
      if (!tr) {
        return;
      }
      var td = tr.querySelector('td');
      if (!td) {
        return;
      }
      if (td.offsetHeight !== this.state.rowHeight) {
        this.setState({ rowHeight: td.offsetHeight });
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.checkShowSettings(this.props.headers);
      window.removeEventListener('resize', this.EVT_EMITTER);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var name = this.props.name;
      var sort = this.state.sort;

      this.checkShowSettings(nextProps.headers);
      this.sortData(sort.key, sort.asc, nextProps.data);
      this.state.data = nextProps.data;
      var headers = nextProps.name === name ? this.sortColumnOrder(nextProps.headers) : nextProps.headers;
      if (name !== nextProps.name) {
        this.getHeaderStatus(headers);
      }
      this.setState(headers);
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this.state.data[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var row = _step.value;

          if (row.flashType === _FlushTypes2.default.NEED_FLASH) {
            row.flashType = _FlushTypes2.default.NONE;
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      this.markCheckState();
    }
  }, {
    key: 'markAllCheckState',
    value: function markAllCheckState() {
      var _this4 = this;

      var _state3 = this.state,
          data = _state3.data,
          checkState = _state3.checkState;
      var keyName = this.props.keyName;

      this.state.allCheckState = 'hidden';
      if (!Array.isArray(data)) {
        return;
      }
      (0, _forEach2.default)(data, function (d) {
        if (d.existCheck && d.canSelect) {
          _this4.state.allCheckState = 'selected';
          if (!checkState[d[keyName]]) {
            _this4.state.allCheckState = 'unselected';
            return false;
          }
        }
      });
    }
  }, {
    key: 'markCheckState',
    value: function markCheckState() {
      var _props2 = this.props,
          selectAble = _props2.selectAble,
          isMultiSelect = _props2.isMultiSelect,
          showCheckbox = _props2.showCheckbox,
          keyName = _props2.keyName,
          onSelected = _props2.onSelected;
      var _state4 = this.state,
          data = _state4.data,
          checkState = _state4.checkState;

      if (!Array.isArray(data)) {
        return;
      }
      var hideRows = [];
      data.map(function (d, i) {
        d[keyName] = d[keyName] || (0, _blueimpMd2.default)(JSON.stringify(d));
        d.canSelect = false;
        d.existCheck = false;
        if (selectAble) {
          if (!showCheckbox || showCheckbox(d)) {
            d.canSelect = true;
            if (isMultiSelect) {
              d.existCheck = true;
            }
          } else {
            checkState[d[keyName]] = false;
            hideRows.push(d);
            d.existCheck = true;
          }
        }
      });
      if (hideRows.length > 0 && onSelected) {
        onSelected(false, hideRows);
      }
      this.markAllCheckState();
    }
  }, {
    key: 'onResizeTable',
    value: function onResizeTable() {
      var body = this.refs.tableBody;
      if (!body) {
        return;
      }
      var wNew = body.offsetWidth;
      var hNew = body.offsetHeight;
      var _state$bodySize = this.state.bodySize,
          w = _state$bodySize.w,
          h = _state$bodySize.h;

      if (w !== wNew && wNew !== 0 || h !== hNew && hNew !== 0) {
        this.setHeaderWidth();
        this.state.bodySize = { w: wNew, h: hNew };
      }
    }
  }, {
    key: 'flashRow',
    value: function flashRow() {
      if (this.state.data instanceof Array) {
        var bNeedUpdate = false;
        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = this.state.data[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var row = _step2.value;

            if (row.flashType === _FlushTypes2.default.PREPARE) {
              bNeedUpdate = true;
              row.flashType = _FlushTypes2.default.NEED_FLASH;
            } else {
              row.flashType = _FlushTypes2.default.NONE;
            }
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }

        if (bNeedUpdate) {
          this.forceUpdate();
        }
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.setHeaderWidth();
      this.onBodyScroll();
      this.calcShowRows();
      this.calcRowHeight();
      this.flashRow();
    }
  }, {
    key: 'setHeaderWidth',
    value: function setHeaderWidth() {
      var body = this.refs.body;
      if (!body || body.offsetWidth === 0) {
        return;
      }
      var tr = body.querySelector('tr');
      if (!tr) {
        return;
      }

      var headers = this.state.headers;


      var header = this.refs.header;
      var ths = header.querySelectorAll('th');
      var tds = tr.querySelectorAll('td');
      if (tds.length <= 1) {
        return;
      }
      for (var i = tds.length - 1, j = headers.length - 1; i >= 0; i--, j--) {
        if (ths[i]) {
          ths[i].style.width = tds[i].offsetWidth + 'px';
        }
      }
      header.style.width = body.offsetWidth + 'px';
    }
  }, {
    key: 'renderBody',
    value: function renderBody(data) {
      var _this5 = this;

      var _props3 = this.props,
          pageShow = _props3.pageShow,
          selectStyle = _props3.selectStyle,
          keyName = _props3.keyName,
          showIndex = _props3.showIndex;
      var _state5 = this.state,
          headers = _state5.headers,
          showData = _state5.showData,
          checkState = _state5.checkState;

      if (!Array.isArray(data)) {
        return _jsx('tbody', {}, void 0, _jsx('tr', {}, void 0, _jsx('td', {
          colSpan: headers.length
        }, void 0, data)));
      }
      if (showData.to === 0) {
        showData.to = 40;
      }
      var trs = data.map(function (d, i) {
        if (pageShow) {
          if (i < showData.from || i > showData.to) {
            return;
          }
        }
        var tds = [];
        var checkStyle = {};
        if (d.existCheck && !d.canSelect) {
          checkStyle.visibility = 'hidden';
        }
        if (d.existCheck) {
          tds.push(_jsx('td', {
            className: 'td-checkbox',
            style: selectStyle
          }, i, showIndex ? _jsx('span', {
            className: 'index'
          }, void 0, i + 1) : '', _jsx(_checkbox2.default, {
            checked: checkState[d[keyName]],
            style: checkStyle
          })));
        }
        var rowKey = d[keyName];
        headers.map(function (h, j) {
          if (h.hidden || h.showStatus === false) {
            return;
          }
          var content = h.content;
          var tdStyle = {};
          if (typeof content === 'function') {
            content = content(d);
          } else {
            content = d[h.name];
          }
          if (h.width) {
            tdStyle.width = h.width;
          }
          if (h.minWidth) {
            tdStyle.minWidth = h.minWidth;
          }
          if (h.textAlign) {
            tdStyle.textAlign = h.textAlign;
          }

          var classes = '';
          if (typeof h.bodyClass === 'function') {
            classes = h.bodyClass(d);
          } else {
            classes = h.bodyClass;
          }
          tds.push(_jsx('td', {
            className: classes,
            style: tdStyle
          }, d[keyName] + '_' + h.name, content));
        });
        var rowClass = (0, _classnames2.default)('', {
          selected: checkState[d[keyName]] && !_this5.props.isMultiSelect || d.active,
          flash: d.flashType === _FlushTypes2.default.NEED_FLASH,
          error: d.error
        });
        var trStyle = pageShow ? { transform: 'translate3d(0, ' + showData.offset + 'px, 0)' } : {};
        return _react2.default.createElement(
          'tr',
          { style: trStyle, className: rowClass, ref: 'row_' + d[keyName], key: rowKey,
            onClick: _this5.onSelect.bind(_this5, i) },
          tds
        );
      });
      return _jsx('tbody', {}, void 0, trs);
    }
  }, {
    key: 'renderPagination',
    value: function renderPagination() {
      var _this6 = this;

      if (!this.props.pagination) {
        return null;
      }
      var checkState = this.state.checkState;
      var keyName = this.props.keyName;

      var props = {
        onChange: function onChange(index) {
          var data = _this6.state.data;
          data.forEach(function (d) {
            checkState[d[keyName]] = false;
          });
          _this6.setState({ index: index, data: data });
        }
      };
      return (0, _react.cloneElement)(this.props.pagination, props);
    }
  }, {
    key: 'handleWheel',
    value: function handleWheel(e) {
      var scrollDeltaY = e.deltaY / 100 * 30;
      var scrollNode = this.refs.bodyScroll;
      var scrollTop = scrollNode.scrollTop;
      scrollTop = scrollTop + scrollDeltaY;
      if (scrollTop < 0) {
        scrollTop = 0;
      } else if (scrollTop > scrollNode.scrollHeight - scrollNode.offsetHeight) {
        scrollTop = scrollNode.scrollHeight - scrollNode.offsetHeight;
      }
      scrollNode.scrollTop = scrollTop;
    }
  }, {
    key: 'handleScroll',
    value: function handleScroll() {
      var _props4 = this.props,
          refresh = _props4.refresh,
          pageShow = _props4.pageShow;

      var bodyScroll = this.refs.bodyScroll;
      this.state.scrollPos = bodyScroll.scrollTop;
      this.state.scrollHeight = bodyScroll.scrollHeight;
      if (bodyScroll.scrollTop + bodyScroll.clientHeight + 30 > bodyScroll.scrollHeight && bodyScroll.scrollTop > 0) {
        if (typeof refresh === 'function') {
          refresh();
        }
      }
      this.calcShowRows();
      if (!pageShow) {
        this.refs.body.style.marginTop = -1 * this.state.scrollPos + 'px';
      }
    }
  }, {
    key: 'calcShowRows',
    value: function calcShowRows() {
      var pageShow = this.props.pageShow;
      var _state6 = this.state,
          scrollPos = _state6.scrollPos,
          showData = _state6.showData,
          data = _state6.data,
          rowHeight = _state6.rowHeight;

      if (!pageShow) {
        return;
      }
      var body = this.refs.body;
      var bodyHeight = this.refs.tableBody.clientHeight;
      var bodyScroll = this.refs.bodyScroll;
      if (bodyScroll.scrollHeight <= bodyHeight) {
        if (showData.from !== 0) {
          this.setState({ showData: { from: 0, to: 40, offset: 0 } });
        }
        body.style.marginTop = '0px';
        return;
      }
      var startRow = (0, _floor2.default)(scrollPos / rowHeight);
      var endRow = (0, _ceil2.default)(startRow + bodyHeight / rowHeight);
      if (startRow < showData.from || endRow > showData.to) {
        var cacheLen = 10;
        var cacheFrom = startRow > cacheLen ? startRow - cacheLen : 0;
        var cacheTo = endRow + cacheLen;
        for (var i = cacheFrom; i <= cacheTo; i++) {
          if (data[i]) {
            data[i].flashType = _FlushTypes2.default.NONE;
          }
        }
        var offset = (0, _floor2.default)(cacheFrom * rowHeight);
        var _showData = { from: cacheFrom, to: cacheTo, offset: offset };
        this.setState({ showData: _showData });
      } else {
        body.style.marginTop = -1 * scrollPos + 'px';
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate() {
      if (this.refs.tableHeader.isDraggingColumn()) {
        return false;
      }
      return true;
    }
  }, {
    key: 'sortColumnOrder',
    value: function sortColumnOrder(headers) {
      var colInfo = this.state.colInfo;

      if ((0, _isEmpty2.default)(colInfo)) {
        return headers;
      }
      return (0, _sortBy2.default)(headers, function (n) {
        if (!colInfo[n.name]) {
          console.warn('table column not exist :', n.name);
        }
        return colInfo[n.name].index;
      });
    }
  }, {
    key: 'changeColumnOrder',
    value: function changeColumnOrder(colInfo) {
      this.state.colInfo = colInfo;
      this.setState({
        headers: this.sortColumnOrder(this.state.headers)
      });
    }
  }, {
    key: 'getAllCheckState',
    value: function getAllCheckState() {
      return this.state.checkState;
    }
  }, {
    key: 'setCheckState',
    value: function setCheckState(data, isChecked) {
      var checkState = this.state.checkState;

      if (this.props.isMultiSelect) {
        data.map(function (id) {
          checkState[id] = isChecked;
        });
      } else {
        this.state.checkState = {};
        this.state.checkState[data[0]] = isChecked;
      }
    }
  }, {
    key: 'onCommand',
    value: function onCommand(nCmd) {
      var _state7 = this.state,
          headers = _state7.headers,
          defaultHeaderStatus = _state7.defaultHeaderStatus;

      switch (nCmd) {
        case 'TABLE_SETTING':
          this.refs.settingsModal.showModal(headers, defaultHeaderStatus);
          break;
        case 'TABLE_DEFAULT':
          (0, _forEach2.default)(headers, function (head) {
            head.showStatus = defaultHeaderStatus[head.name];
          });
          this.updateHeaderStatus();
          this.refs.tableHeader.setDefaultHeaders(defaultHeaderStatus);
          break;
      }
    }
  }, {
    key: 'onContextMenu',
    value: function onContextMenu(e) {
      if (!this.state.showSettings) {
        return;
      }
      e.preventDefault();
      if (!(0, _dom.isExistedListContainer)()) {
        (0, _dom.createListContainer)();
      }
      var ptPos = { left: e.pageX, top: e.pageY };
      var props = {
        command: [{
          text: '表格设置',
          id: 'TABLE_SETTING'
        }, {
          text: '恢复默认',
          id: 'TABLE_DEFAULT'
        }],
        ptPos: ptPos,
        isShown: true,
        onCommand: this.onCommand.bind(this),
        parentNode: this.refs.table
      };
      _reactDom2.default.render(_react2.default.createElement(_popupmenu2.default, props), _dom.listContainer);
    }
  }, {
    key: 'onSettingHandle',
    value: function onSettingHandle(type) {
      if (type === 'ok') {
        this.updateHeaderStatus();
      }
    }
  }, {
    key: 'checkShowSettings',
    value: function checkShowSettings(headers) {
      var _this7 = this;

      this.state.showSettings = false;
      (0, _forEach2.default)(headers, function (header) {
        if (header.showStatus === true || header.showStatus === false) {
          _this7.state.showSettings = true;
          return false;
        }
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _state8 = this.state,
          data = _state8.data,
          allCheckState = _state8.allCheckState,
          rowHeight = _state8.rowHeight;
      var _props5 = this.props,
          width = _props5.width,
          style = _props5.style,
          multiTableReflection = _props5.multiTableReflection;

      var scrollHeight = data.length * rowHeight;
      var tableStyle = _extends({}, style, {
        width: width
      });
      var className = (0, _classnames2.default)('table', this.props.className);

      return _react2.default.createElement(
        'div',
        { ref: 'table', style: tableStyle, className: className, onContextMenu: this.onContextMenu.bind(this) },
        _react2.default.createElement(
          'div',
          { className: 'header-container', ref: 'headerContainer' },
          _react2.default.createElement(
            'table',
            { ref: 'header' },
            _react2.default.createElement(_TableHeader2.default, {
              ref: 'tableHeader',
              name: this.props.name,
              headers: this.state.headers,
              selectAble: this.props.selectAble && this.props.isMultiSelect && data.length > 0,
              selectStyle: this.props.selectStyle,
              onSelect: this.onSelect.bind(this),
              onSort: this.onSort.bind(this),
              changeColumnOrder: this.changeColumnOrder.bind(this),
              canReorderColumns: this.props.canReorderColumns,
              onSelectAll: this.props.selectAll,
              multiTableReflection: multiTableReflection,
              allCheckState: allCheckState
            })
          )
        ),
        _react2.default.createElement(
          'div',
          {
            ref: 'tableBody',
            className: 'body-container',
            onWheel: this.handleWheel.bind(this),
            onScroll: this.onBodyScroll.bind(this) },
          _jsx('div', {
            style: { height: scrollHeight }
          }, void 0, _react2.default.createElement(
            'table',
            { ref: 'body' },
            this.renderBody(data)
          )),
          _react2.default.createElement(
            'div',
            { className: 'body-scroll', onScroll: this.handleScroll.bind(this), ref: 'bodyScroll' },
            _jsx('div', {
              style: { height: scrollHeight, width: 8 }
            })
          )
        ),
        this.renderPagination(),
        _react2.default.createElement(_SettingsModal2.default, { ref: 'settingsModal', onBtnHandle: this.onSettingHandle.bind(this), onConfirm: this.updateHeaderStatus.bind(this) })
      );
    }
  }]);

  return Table;
}(_react.Component), _class.defaultProps = {
  data: [],
  selectAble: true,
  selectStyle: {
    width: 46,
    textAlign: 'right'
  },
  isMultiSelect: true,
  canReorderColumns: false,
  name: 'table',
  resizable: false,
  pageShow: true,
  multiTableReflection: false,
  keyName: 'id',
  showIndex: false,
  rowHeight: 40
}, _class.contextTypes = {
  businessKey: _propTypes2.default.string,
  componentName: _propTypes2.default.string
}, _temp);
exports.default = Table;