'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TableHeaderColumn = require('./TableHeaderColumn');

var _TableHeaderColumn2 = _interopRequireDefault(_TableHeaderColumn);

var _checkbox = require('../checkbox');

var _checkbox2 = _interopRequireDefault(_checkbox);

var _DragAway2 = require('../../utils/DragAway');

var _DragAway3 = _interopRequireDefault(_DragAway2);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _filter = require('lodash/filter');

var _filter2 = _interopRequireDefault(_filter);

var _clone = require('lodash/clone');

var _clone2 = _interopRequireDefault(_clone);

var _forEach = require('lodash/forEach');

var _forEach2 = _interopRequireDefault(_forEach);

var _keys = require('lodash/keys');

var _keys2 = _interopRequireDefault(_keys);

var _mapValues = require('lodash/mapValues');

var _mapValues2 = _interopRequireDefault(_mapValues);

var _min = require('lodash/min');

var _min2 = _interopRequireDefault(_min);

var _sscAnalytics = require('ssc-analytics');

var _storageUtils = require('../../utils/storageUtils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var oldTableVersion = '1.4';
var tableVersion = '1.5';

var globalTableMap = {};
var globalTableSort = {};

var TableHeader = (_temp = _class = function (_DragAway) {
  _inherits(TableHeader, _DragAway);

  function TableHeader(props) {
    _classCallCheck(this, TableHeader);

    var _this = _possibleConstructorReturn(this, (TableHeader.__proto__ || Object.getPrototypeOf(TableHeader)).call(this, props));

    _this.state = {
      sort: {},
      bColumnDragging: false,
      bCoumnResizing: false,
      bStartDrag: false,
      draggingColumn: {},
      hoverColumn: {},
      dragBeginPt: {},
      draggingPt: {},
      preSwapPt: { x: -1, y: -1 },
      colInfo: {},
      firstLeft: -1
    };
    return _this;
  }

  _createClass(TableHeader, [{
    key: 'setDefaultHeaders',
    value: function setDefaultHeaders(defaultHeaders) {
      var name = this.props.name;

      var colInfo = {};
      (0, _forEach2.default)((0, _keys2.default)(defaultHeaders), function (header, i) {
        colInfo[header] = { index: i, name: header };
      });
      this.state.colInfo[name] = colInfo;
      this.initColInfo(this.props.headers, name);
    }
  }, {
    key: 'initColInfo',
    value: function initColInfo(headers, name) {
      var _this2 = this;

      if (!this.props.canReorderColumns) {
        return;
      }
      var colInfo = this.state.colInfo[name];
      if (!colInfo && _storageUtils.canUseLocalStorage) {
        colInfo = JSON.parse((0, _storageUtils.getItem)('table_' + tableVersion + '_' + name));
        this.state.colInfo[name] = colInfo;
      }
      if (!colInfo) {
        this.state.colInfo[name] = {};
        headers.map(function (header, i) {
          _this2.state.colInfo[name][header.name] = { index: i, name: header.name };
        });
        colInfo = this.state.colInfo[name];
      } else {
        if (_storageUtils.canUseLocalStorage) {
          var storageData = (0, _mapValues2.default)(colInfo, function (n) {
            return { index: n.index, name: n.name };
          });
          (0, _storageUtils.setItem)('table_' + tableVersion + '_' + name, JSON.stringify(storageData));
          (0, _storageUtils.removeItem)('table_' + oldTableVersion + '_' + name);
        }
      }
      var changeColumnOrder = this.props.changeColumnOrder;

      if ((0, _isFunction2.default)(changeColumnOrder)) {
        changeColumnOrder(colInfo);
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.name !== nextProps.name) {
        this.initColInfo(nextProps.headers, nextProps.name);
      }
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          name = _props.name,
          headers = _props.headers,
          multiTableReflection = _props.multiTableReflection;

      if (name && multiTableReflection) {
        if (!(0, _isArray2.default)(globalTableMap[name])) {
          globalTableMap[name] = [];
        }
        globalTableMap[name].push(this);
        if (globalTableSort[name]) {
          var _globalTableSort$name = globalTableSort[name],
              colName = _globalTableSort$name.colName,
              asc = _globalTableSort$name.asc;

          this.sortCol(colName, asc);
        }
      }

      this.registerDragAway(this.onMouseMoveCapture.bind(this), this.onMouseUpCapture.bind(this));
      this.initColInfo(headers, name);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var _this3 = this;

      var _props2 = this.props,
          name = _props2.name,
          multiTableReflection = _props2.multiTableReflection;

      if (name && multiTableReflection) {
        globalTableMap[name] = (0, _filter2.default)(globalTableMap[name], function (d) {
          return d !== _this3;
        });
        if (globalTableMap[name].length === 0) {
          globalTableSort[name] = undefined;
        }
      }
    }
  }, {
    key: 'selectAll',
    value: function selectAll(e) {
      var _props3 = this.props,
          onSelectAll = _props3.onSelectAll,
          onSelect = _props3.onSelect;

      var checked = e.target.checked;
      if (onSelectAll) {
        onSelectAll(checked);
        return;
      }
      if (onSelect) {
        onSelect('all', e);
      }
    }
  }, {
    key: 'hoverColumn',
    value: function hoverColumn(column) {
      this.state.hoverColumn = column;
    }
  }, {
    key: 'onMouseDown',
    value: function onMouseDown(e) {
      var _this4 = this;

      if (e.button === 0 && this.props.canReorderColumns) {
        var colInfo = this.state.colInfo[this.props.name];
        this.bindDragAway();

        this.props.headers.map(function (header) {
          var name = header.name;
          var col = colInfo[name];
          col.originIndex = col.index;
          if (_this4.refs[name]) {
            var th = _this4.refs[name].refs[name];
            col.left = th.offsetLeft;
            col.originLeft = th.offsetLeft;
            col.width = th.offsetWidth;
            if (e.clientX >= th.offsetLeft && e.clientX < th.offsetLeft + th.offsetWidth) {
              _this4.state.draggingColumn = (0, _clone2.default)(col);
            }
            if (col.index === 0) {
              _this4.state.firstLeft = col.left;
            }
          }
        });
        this.state.bColumnDragging = true;
        this.state.dragBeginPt = { x: e.clientX, y: e.clientY };
        this.state.draggingPt = { x: e.clientX, y: e.clientY };
      }
    }
  }, {
    key: 'changeColumnOrder',
    value: function changeColumnOrder(colInfo) {
      var name = this.props.name;

      this.state.colInfo[name] = colInfo;
      if ((0, _isFunction2.default)(this.props.changeColumnOrder)) {
        this.props.changeColumnOrder(colInfo);
      }
    }
  }, {
    key: 'notifyChangeCol',
    value: function notifyChangeCol() {
      var _this5 = this;

      var name = this.props.name;
      var colInfo = this.state.colInfo;

      (0, _forEach2.default)(globalTableMap[name], function (t) {
        if (t !== _this5) {
          t.changeColumnOrder(colInfo[name]);
        }
      });
    }
  }, {
    key: 'onMouseUpCapture',
    value: function onMouseUpCapture(e) {
      var _props4 = this.props,
          name = _props4.name,
          headers = _props4.headers,
          multiTableReflection = _props4.multiTableReflection;

      if (this.state.bColumnDragging && e.button === 0) {
        this.unbindDragAway();
        this.state.bColumnDragging = false;
        this.initColInfo(headers, name);
        if (multiTableReflection) {
          this.notifyChangeCol();
        }
        this.setState({
          bStartDrag: false,
          draggingColumn: {},
          preSwapPt: { x: -1, y: -1 }
        });
      }
    }
  }, {
    key: 'isDraggingColumn',
    value: function isDraggingColumn() {
      return this.state.bColumnDragging;
    }
  }, {
    key: 'onMouseMoveCapture',
    value: function onMouseMoveCapture(e) {
      var _this6 = this;

      if (this.state.bColumnDragging) {
        var x = e.clientX;
        var y = e.clientY;

        var colInfo = this.state.colInfo[this.props.name];
        this.props.headers.map(function (header, i) {
          var col = colInfo[header.name];
          if (x >= col.left && x < col.left + col.width) {
            _this6.state.hoverColumn = col;
          }
        });

        var _state = this.state,
            draggingColumn = _state.draggingColumn,
            hoverColumn = _state.hoverColumn,
            dragBeginPt = _state.dragBeginPt,
            draggingPt = _state.draggingPt,
            preSwapPt = _state.preSwapPt,
            firstLeft = _state.firstLeft;

        // change column

        var dragCol = colInfo[draggingColumn.name];
        if (!dragCol || !hoverColumn) {
          return;
        }
        var bSwapLeft = dragCol.left > hoverColumn.left;
        var moveDirection = void 0;
        var minWidth = (0, _min2.default)([draggingColumn.width, hoverColumn.width]) / 2;
        if (preSwapPt.x === -1) {
          if (x - dragBeginPt.x > minWidth) {
            moveDirection = 'right';
          } else if (dragBeginPt.x - x > minWidth) {
            moveDirection = 'left';
          }
        } else {
          if (draggingPt.x - preSwapPt.x > 10) {
            moveDirection = 'right';
          } else if (preSwapPt.x - draggingPt.x > 10) {
            moveDirection = 'left';
          }
        }
        if ((moveDirection === 'left' && bSwapLeft || moveDirection === 'right' && !bSwapLeft) && hoverColumn.name !== draggingColumn.name) {
          var indexCol = {};
          var dragNewIndex = hoverColumn.index;
          (0, _forEach2.default)(colInfo, function (n) {
            if (n.originIndex === dragCol.originIndex) {
              indexCol['index' + dragNewIndex] = dragCol;
              return;
            }
            var originIndex = n.originIndex;
            if (dragNewIndex > dragCol.originIndex && originIndex > dragCol.originIndex && originIndex <= dragNewIndex) {
              n.index = originIndex - 1;
            } else if (dragNewIndex < dragCol.originIndex && originIndex >= dragNewIndex && originIndex < dragCol.originIndex) {
              n.index = originIndex + 1;
            } else {
              n.index = originIndex;
            }
            indexCol['index' + n.index] = n;
          });
          dragCol.index = dragNewIndex;
          var k = 0;
          while (indexCol['index' + k]) {
            var index = 'index' + k;
            if (k === 0) {
              indexCol[index].left = firstLeft;
            } else {
              indexCol[index].left = indexCol['index' + (k - 1)].left + indexCol['index' + (k - 1)].width;
            }
            k++;
          }
          this.state.preSwapPt = { x: draggingPt.x, y: draggingPt.y };
        }
        this.setState({
          bStartDrag: true,
          draggingPt: { x: x, y: y }
        });
      }
    }
  }, {
    key: 'sortCol',
    value: function sortCol(name, asc) {
      var onSort = this.props.onSort;

      onSort(name, asc);
      this.state.sort = { name: name, asc: asc };
    }
  }, {
    key: 'onSort',
    value: function onSort(header, colName, asc) {
      var _props5 = this.props,
          name = _props5.name,
          multiTableReflection = _props5.multiTableReflection;

      if (multiTableReflection) {
        globalTableSort[name] = { colName: colName, asc: asc };
        (0, _forEach2.default)(globalTableMap[name], function (t) {
          t.sortCol(colName, asc);
        });
      } else {
        this.sortCol(colName, asc);
      }

      (0, _sscAnalytics.tracker)('click', this.context.businessKey + '.' + header.header + '.' + asc, this.context.componentName + '.TableHeader');
    }
  }, {
    key: 'render',
    value: function render() {
      var _this7 = this;

      var columns = [];
      var colInfo = this.state.colInfo[this.props.name];
      var _state2 = this.state,
          sort = _state2.sort,
          draggingColumn = _state2.draggingColumn,
          dragBeginPt = _state2.dragBeginPt,
          draggingPt = _state2.draggingPt,
          bStartDrag = _state2.bStartDrag,
          bColumnDragging = _state2.bColumnDragging;
      var _props6 = this.props,
          allCheckState = _props6.allCheckState,
          selectAble = _props6.selectAble;

      if (selectAble) {
        var selectStyle = this.props.selectStyle;

        var checkVisible = allCheckState === 'hidden' ? 'hidden' : 'visible';
        columns.push(_jsx(_TableHeaderColumn2.default, {
          style: selectStyle,
          textAlign: selectStyle.textAlign,
          className: 'td-checkbox',
          name: '$checkbox',
          header: _jsx(_checkbox2.default, {
            onChange: this.selectAll.bind(this),
            checked: allCheckState === 'selected',
            style: { visibility: checkVisible }
          })
        }, 'checkbox'));
      }
      this.props.headers.map(function (header, i) {
        if (header.hidden || header.showStatus === false) {
          return;
        }

        var props = {
          key: header.name || i,
          onSort: _this7.onSort.bind(_this7, header),
          sort: sort
        };

        var style = {};
        var className = '';
        if (bColumnDragging) {
          var col = colInfo[header.name];
          if (draggingColumn.name === header.name && bStartDrag) {
            style = {
              cursor: 'move',
              left: draggingPt.x - dragBeginPt.x,
              backgroundColor: '#434345',
              zIndex: 1000
            };
            className = 'dragging';
          } else {
            if (col) {
              style = {
                left: col.left - col.originLeft,
                transition: 'left 0.4s'
              };
            }
          }
        }
        columns.push(_react2.default.createElement(_TableHeaderColumn2.default, _extends({ className: className, ref: header.name }, header, props, { style: style })));
      });
      return _jsx('thead', {}, void 0, _jsx('tr', {
        onMouseDown: this.onMouseDown.bind(this)
      }, void 0, columns));
    }
  }]);

  return TableHeader;
}((0, _DragAway3.default)(_react.Component)), _class.propTypes = {
  selectAble: _propTypes2.default.bool,
  selectStyle: _propTypes2.default.object,
  headers: _propTypes2.default.array,
  onSelect: _propTypes2.default.func,
  onSort: _propTypes2.default.func,
  canReorderColumns: _propTypes2.default.bool,
  name: _propTypes2.default.string,
  changeColumnOrder: _propTypes2.default.func,
  onSelectAll: _propTypes2.default.func,
  multiTableReflection: _propTypes2.default.bool,
  allCheckState: _propTypes2.default.string
}, _class.defaultProps = {
  headers: [],
  canReorderColumns: false,
  allCheckState: 'unselected'
}, _class.contextTypes = {
  businessKey: _propTypes2.default.string,
  componentName: _propTypes2.default.string
}, _temp);
exports.default = TableHeader;