'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _isString = require('lodash/isString');

var _isString2 = _interopRequireDefault(_isString);

var _isObject = require('lodash/isObject');

var _isObject2 = _interopRequireDefault(_isObject);

var _eq = require('lodash/eq');

var _eq2 = _interopRequireDefault(_eq);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _layout = require('../layout');

var _Tabs = require('./Tabs');

var _Tabs2 = _interopRequireDefault(_Tabs);

var _sscAnalytics = require('ssc-analytics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component,
    Children = _react2.default.Children;
var TabWidget = (_temp = _class = function (_Component) {
  _inherits(TabWidget, _Component);

  function TabWidget(props) {
    _classCallCheck(this, TabWidget);

    var _this = _possibleConstructorReturn(this, (TabWidget.__proto__ || Object.getPrototypeOf(TabWidget)).call(this, props));

    _this.handleTabChange = function (index) {
      var onChange = _this.props.onChange;

      _this.setState({ selectedIndex: index });
      if ((0, _isFunction2.default)(onChange)) {
        onChange(index);
      }
      (0, _sscAnalytics.tracker)('click', _this.context.businessKey + '.' + _this.getTabText(_this.props.tabs[index]), _this.context.componentName);
    };

    _this.getSelected = function () {
      return _this.state.selectedIndex;
    };

    _this.renderTabs = function () {
      var _this$props = _this.props,
          tabs = _this$props.tabs,
          right = _this$props.right,
          direction = _this$props.direction;
      var selectedIndex = _this.state.selectedIndex;

      return _jsx(_Tabs2.default, {
        className: 'ss-tabs-' + direction,
        tabs: tabs,
        selectedIndex: selectedIndex,
        onChange: _this.handleTabChange,
        right: (0, _isNil2.default)(right) ? null : right[selectedIndex],
        direction: direction
      });
    };

    _this.renderChildren = function () {
      var _this$props2 = _this.props,
          children = _this$props2.children,
          isLazy = _this$props2.isLazy;
      var selectedIndex = _this.state.selectedIndex;

      var childes = [];
      Children.map(children, function (child, index) {
        var show = (0, _isObject2.default)(child) && (0, _isEqual2.default)(selectedIndex, index);
        var style = {
          flexDirection: 'column',
          display: show ? 'flex' : 'none'
        };
        var ele = _jsx('div', {
          className: 'ss-tab-widget-child',
          style: style
        }, 'tab-widget' + index, child);
        if (isLazy) {
          show ? childes.push(ele) : null;
          return false;
        } else {
          childes.push(ele);
        }
      });
      return childes;
    };

    _this.state = {
      selectedIndex: props.selectedIndex
    };
    return _this;
  }

  _createClass(TabWidget, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var selectedIndex = nextProps.selectedIndex;

      if (selectedIndex !== this.props.selectedIndex && !(0, _isNil2.default)(selectedIndex) && !(0, _eq2.default)(selectedIndex, this.state.selectedIndex)) {
        this.setState({ selectedIndex: selectedIndex });
      }
    }
  }, {
    key: 'getTabText',
    value: function getTabText(tab) {
      var text = 'EMPTY';
      if ((0, _isString2.default)(tab)) {
        text = tab;
      } else if ((0, _isObject2.default)(tab)) {
        text = tab.props.text;
      }
      return text;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          style = _props.style,
          direction = _props.direction;

      var tabs = this.renderTabs();
      var props = {
        className: (0, _classnames2.default)([className, 'ss-tab-widget']),
        style: style,
        header: (0, _isEqual2.default)(direction, 'top') ? tabs : '',
        footer: (0, _isEqual2.default)(direction, 'bottom') ? tabs : ''
      };
      return _react2.default.createElement(
        _layout.LayoutGV,
        props,
        this.renderChildren()
      );
    }
  }]);

  return TabWidget;
}(Component), _class.defaultProps = {
  selectedIndex: 0,
  isLazy: true,
  direction: 'top'
}, _class.contextTypes = {
  businessKey: _propTypes2.default.string,
  componentName: _propTypes2.default.string
}, _temp);
exports.default = TabWidget;