'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _eq = require('lodash/eq');

var _eq2 = _interopRequireDefault(_eq);

var _Tab = require('./Tab');

var _Tab2 = _interopRequireDefault(_Tab);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = _react2.default.Component;

var _ref = _jsx('div', {
  className: 'tab-space'
});

var Tabs = (_temp = _class = function (_Component) {
  _inherits(Tabs, _Component);

  function Tabs(props) {
    _classCallCheck(this, Tabs);

    var _this = _possibleConstructorReturn(this, (Tabs.__proto__ || Object.getPrototypeOf(Tabs)).call(this, props));

    _this.handleChange = function (index) {
      var onChange = _this.props.onChange;

      _this.setState({ selectedIndex: index });
      if ((0, _isFunction2.default)(onChange)) {
        onChange(index);
      }
    };

    _this.renderTabs = function () {
      var tabs = _this.props.tabs;
      var selectedIndex = _this.state.selectedIndex;

      return (0, _map2.default)(tabs, function (tab, index) {
        return _jsx(_Tab2.default, {
          text: tab,
          index: index,
          active: selectedIndex === index,
          onClick: _this.handleChange.bind(_this)
        }, 'tab-' + index);
      });
    };

    _this.renderRight = function () {
      var right = _this.props.right;

      return (0, _isNil2.default)(right) ? '' : _jsx('div', {
        className: 'ss-tab-right'
      }, void 0, right);
    };

    _this.state = {
      selectedIndex: props.selectedIndex
    };
    return _this;
  }

  _createClass(Tabs, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var selectedIndex = nextProps.selectedIndex;

      if (!(0, _isNil2.default)(selectedIndex) && !(0, _eq2.default)(selectedIndex, this.state.selectedIndex)) {
        this.setState({ selectedIndex: selectedIndex });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          style = _props.style,
          direction = _props.direction;

      var props = {
        className: (0, _classnames2.default)(['ss-tabs', className]),
        style: style
      };
      return _jsx('div', {
        className: 'ss-tabs-warp ss-tabs-warp-' + direction
      }, void 0, _react2.default.createElement(
        'ul',
        props,
        this.renderTabs()
      ), _ref, this.renderRight());
    }
  }]);

  return Tabs;
}(Component), _class.defaultProps = {
  tabs: [],
  selectedIndex: 0,
  direction: 'top'
}, _temp);
exports.default = Tabs;