'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp; /**
                    * Copyright @2016 www.sumscope.com
                    */

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _button = require('../button');

var _button2 = _interopRequireDefault(_button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Upload = (_temp = _class = function (_React$Component) {
  _inherits(Upload, _React$Component);

  function Upload(props) {
    _classCallCheck(this, Upload);

    var _this = _possibleConstructorReturn(this, (Upload.__proto__ || Object.getPrototypeOf(Upload)).call(this, props));

    _this.handleClick = _this.handleClick.bind(_this);
    _this.handleSelectFile = _this.handleSelectFile.bind(_this);
    return _this;
  }

  _createClass(Upload, [{
    key: 'handleClick',
    value: function handleClick() {
      if (this.props.disabled) {
        return;
      }
      this.refs['uploadForm'].reset();
      this.refs['uploadFile'].click();
    }
  }, {
    key: 'handleSelectFile',
    value: function handleSelectFile() {
      if ((0, _isFunction2.default)(this.props.onSelect)) {
        this.props.onSelect();
      } else {
        this.loadFileData();
      }
    }
  }, {
    key: 'loadFileData',
    value: function loadFileData() {
      var _this2 = this;

      // 异步读取文件内容
      new Promise(function (resolve, reject) {
        var uploadFile = _this2.refs['uploadFile'].files[0];
        var reader = new FileReader();
        reader.onload = resolve;
        reader.readAsBinaryString(uploadFile);
      }).then(function (e) {
        var binaryData = e.target.result;
        var fileData = null;
        switch (_this2.props.fileType) {
          case 'EXCEL':
            fileData = _this2.analysisExcel(binaryData);
            break;
        }
        if (!(0, _isEmpty2.default)(fileData)) {
          if ((0, _isFunction2.default)(_this2.props.onLoad)) {
            _this2.props.onLoad(fileData);
          }
        } else {
          if ((0, _isFunction2.default)(_this2.props.onError)) {
            _this2.props.onError('导入文件数据读取失败');
          }
        }
      }).catch(function (error) {
        if ((0, _isFunction2.default)(_this2.props.onError)) {
          _this2.props.onError(error.message);
        }
      });
    }
  }, {
    key: 'analysisExcel',
    value: function analysisExcel(binaryData) {
      try {
        var result = [];
        require.ensure([], function (require) {
          var XLSX = require('xlsx');
          var workbook = XLSX.read(binaryData, { type: 'binary' });
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = workbook.SheetNames[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var sheetName = _step.value;

              var worksheet = workbook.Sheets[sheetName];
              var sheetRange = XLSX.utils.decode_range(worksheet['!ref']);
              var sheetData = [];
              for (var rowNum = sheetRange.s.r; rowNum <= sheetRange.e.r; rowNum++) {
                var rowData = [];
                var hasVal = false;
                for (var colNum = sheetRange.s.c; colNum <= sheetRange.e.c; colNum++) {
                  var cellRef = XLSX.utils.encode_cell({ c: colNum, r: rowNum });
                  var cell = worksheet[cellRef];
                  if (cell && cell.v !== '') {
                    rowData.push(cell.v);
                    hasVal = true;
                  } else {
                    rowData.push(null);
                  }
                }
                if (hasVal) {
                  sheetData.push(rowData);
                }
              }
              result.push(sheetData);
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }
        });
        return result;
      } catch (error) {
        throw new Error('导入文件格式不正确');
      }
    }
  }, {
    key: 'addFile',
    value: function addFile() {
      var _this3 = this;

      var accept = void 0;
      switch (this.props.fileType) {
        case 'EXCEL':
          accept = ['.xls', '.xlsx'];
          break;
      }
      return _react2.default.createElement(
        'form',
        { key: 'form', ref: 'uploadForm', style: { display: 'none' } },
        _react2.default.createElement('input', {
          type: 'file',
          ref: 'uploadFile',
          onChange: function onChange() {
            return _this3.handleSelectFile();
          },
          accept: accept
        })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var _props = this.props,
          style = _props.style,
          disabled = _props.disabled,
          children = _props.children;

      return _jsx(_button2.default, {
        style: style,
        disabled: disabled,
        onClick: function onClick() {
          return _this4.handleClick();
        }
      }, void 0, children, this.addFile());
    }
  }]);

  return Upload;
}(_react2.default.Component), _class.defaultProps = {
  disabled: false,
  fileType: 'EXCEL'
}, _temp);
exports.default = Upload;