'use strict';

/**
 * Created by happia.zhang on 2016/6/28.
 */
module.exports = {
  'email': /^[a-z0-9!#$%&'*+/=?^_`{|}~.-]+@[a-z0-9-]+(\.[a-z0-9-]+)*$/i,
  'url': /^(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?$/,
  'number': /^\s*(\-|\+)?(\d+|(\d*(\.\d*)))*\s*$/,
  /* 'date': /^(\d{4})-(\d{2})-(\d{2})$/,*/
  'alpha': /^[a-z ._-]+$/i,
  'alphanum': /^[a-z0-9_]+$/i,
  'password': /^[\x00-\xff]+$/,
  'tel': /^[\d\s ().-]+$/,
  'hex': /^#[0-9a-f]{6}?$/i,
  'rgb': new RegExp('^rgb\\(\\s*(0|[1-9]\\d?|1\\d\\d?|2[0-4]\\d|25[0-5])\\s*,\\s*(0|[1-9]\\d?|1\\d\\d?|2[0-4]\\d|25[0-5])\\s*,' + '\\s*(0|[1-9]\\d?|1\\d\\d?|2[0-4]\\d|25[0-5])\\s*\\)$'),
  'rgba': new RegExp('^rgba\\(\\s*(0|[1-9]\\d?|1\\d\\d?|2[0-4]\\d|25[0-5])\\s*,\\s*(0|[1-9]\\d?|1\\d\\d?|2[0-4]\\d|25[0-5])\\s*,' + '\\s*(0|[1-9]\\d?|1\\d\\d?|2[0-4]\\d|25[0-5])\\s*,\\s*((0.[1-9]*)|[01])\\s*\\)$'),
  'hsv': new RegExp('^hsv\\(\\s*(0|[1-9]\\d?|[12]\\d\\d|3[0-5]\\d)\\s*,\\s*((0|[1-9]\\d?|100)%)\\s*,\\s*((0|[1-9]\\d?|100)%)\\s*\\)$'),
  'term': /^\d{1,3}[DMY]?$/i,
  'price': /^(([1-9]\d{0,4})|(\d{0,5}\.[\d]{0,3}))$/,
  'quantity': /^(([1-9]\d{0,3})|(\d{0,4}\.[\d]{0,3}))$/,
  'bp': /^[0-9]{0,3}$/,
  'decimal': function decimal(n) {
    return new RegExp('^(([1-9]\\d*)|(\\d*\\.[\\d]{0,' + n + '}))$');
  }
};